Package: jrSiCKLSNMF
Type: Package
Title: Multimodal Single-Cell Omics Dimensionality Reduction
Version: 1.2.4
Authors@R: 
    c(person("Dorothy","Ellis",email="ddemoreellis@gmail.com",role=c("aut","cre"),
    comment=c(ORCID="0000-0002-8624-0042")),
    person("Susmita","Datta",email="susmita.datta@ufl.edu",role="ths"),
    person("Kenneth","Perkins",role="ctb",
      comment="Util.h function author, http://programmingnotes.org/"),
    person("Renaud","Gaujoux",role="ctb",comment="Author of .nndsvd R adaptation"))
Description: Methods to perform Joint graph Regularized Single-Cell Kullback-Leibler Sparse Non-negative Matrix Factorization ('jrSiCKLSNMF', pronounced "junior sickles NMF") on quality controlled single-cell multimodal omics count data. 'jrSiCKLSNMF' specifically deals with dual-assay scRNA-seq and scATAC-seq data. This package contains functions to extract meaningful latent factors that are shared across omics modalities. These factors enable accurate cell-type clustering and facilitate visualizations. Methods for pre-processing, clustering, and mini-batch updates and other adaptations for larger datasets are also included. For further details on the methods used in this package please see Ellis, Roy, and Datta (2023) <doi:10.3389/fgene.2023.1179439>.
License: GPL-3
Encoding: UTF-8
Imports: Rcpp (>= 1.0.9), igraph, umap, kknn, ggplot2, methods, stats,
        rlang, Matrix,
        data.table,parallel,pbapply,cluster,MASS,clValid,factoextra,
        foreach,irlba,bluster,Rdpack,ggrepel
Suggests: knitr, rmarkdown
LinkingTo: Rcpp, RcppArmadillo, RcppProgress
LazyData: true
LazyDataCompression: xz
VignetteBuilder: knitr
RdMacros: Rdpack
NeedsCompilation: yes
Packaged: 2026-05-15 08:11:04 UTC; dorothy
Author: Dorothy Ellis [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-8624-0042>),
  Susmita Datta [ths],
  Kenneth Perkins [ctb] (Util.h function author,
    http://programmingnotes.org/),
  Renaud Gaujoux [ctb] (Author of .nndsvd R adaptation)
Maintainer: Dorothy Ellis <ddemoreellis@gmail.com>
Depends: R (>= 3.5.0)
Repository: CRAN
Date/Publication: 2026-05-15 12:00:02 UTC
Config/roxygen2/version: 8.0.0
Built: R 4.6.0; aarch64-apple-darwin23; 2026-05-15 13:59:56 UTC; unix
Archs: jrSiCKLSNMF.so.dSYM

useDynLib(jrSiCKLSNMF, .registration=TRUE)
importFrom("Rcpp","evalCpp")
importFrom("bluster","makeKNNGraph","makeSNNGraph")
importFrom("igraph","laplacian_matrix","cluster_louvain")
importFrom("umap","umap","umap.defaults")
importFrom("kknn","specClust")
import("ggplot2")
import("ggrepel")
importFrom("methods","new","as","is")
importFrom("data.table","copy")
importFrom("stats","runif","kmeans","median")
importFrom("rlang",".data","is_empty")
importFrom("MASS","ginv")
import("Matrix")
import("parallel")
import("foreach")
import("pbapply")
import("rlang")
import("cluster")
import("clValid")
import("factoextra")
import("irlba")
importFrom("Rdpack","reprompt")
## export all regularly named functions
## (but allow for private functions whose name starts with a dot).name <- function(...)
exportPattern("^[[:alpha:]]+")

# jrSiCKLSNMF
This package contains code to run joint graph-regularized single-cell Kullback-Leibler Non-negative Matrix Factorization

To install:
```{r package}
install.packages("devtools")
devtools::install_github("ellisdoro/jrSiCKLSNMF")
```

<!-- badges: start -->
[![R-CMD-check](https://github.com/ellisdoro/jrSiCKLSNMF/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/ellisdoro/jrSiCKLSNMF/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----loadjrSiCKLSNMF----------------------------------------------------------
library(jrSiCKLSNMF)

## ----createSickleJr-----------------------------------------------------------
SimData<-jrSiCKLSNMF::SimData
DataMatrices<-SimData$Xmatrices
cell_type<-SimData$cell_type
SimSickleJr<-CreateSickleJr(DataMatrices)
rm(DataMatrices,SimData)

## ----addmetadata--------------------------------------------------------------
SimSickleJr<-AddSickleJrMetadata(SimSickleJr,cell_type,"true_cell_type")
rm(cell_type)

## ----graphlaplacian-----------------------------------------------------------
set.seed(10)
SimSickleJr<-BuildKNNGraphLaplacians(SimSickleJr)

## ----setlambdas---------------------------------------------------------------
SimSickleJr<-SetLambdasandRowReg(SimSickleJr,lambdaWlist=list(10,50),lambdaH=500,rowReg="None")

## ----Normalize----------------------------------------------------------------
SimSickleJr<-NormalizeCountMatrices(SimSickleJr)

## ----determineD---------------------------------------------------------------
SimSickleJr<-PlotLossvsLatentFactors(SimSickleJr,d_vector=4:6,parallel = FALSE,rounds=25)

## ----initializeWH-------------------------------------------------------------
SimSickleJr<-GenerateWmatricesandHmatrix(SimSickleJr,d=10)

## ----usepreviouslycalculated--------------------------------------------------
SimSickleJr<-SetWandHfromWHinitials(SimSickleJr,d=5)

## ----runningjrsickls----------------------------------------------------------
start.time<-Sys.time()
SimSickleJr<-RunjrSiCKLSNMF(SimSickleJr,rounds=1000,differr=1e-5,minibatch=FALSE)
stop.time<-Sys.time()
(time<-stop.time-start.time)

## ----clustering---------------------------------------------------------------
SimSickleJr<-DetermineClusters(SimSickleJr,printclValid=FALSE)
SimSickleJr<-ClusterSickleJr(SimSickleJr,numclusts=3)

## ----UMAPplots----------------------------------------------------------------
SimSickleJr<-CalculateUMAPSickleJr(SimSickleJr)
#Plotting based off of cluster
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,title="K-means clusters")
#Plotting based off of true cell type metadata
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,colorbymetadata="true_cell_type",title="True Cell Types",legendname="True Cell Types")

## ----UMAPplotsWH--------------------------------------------------------------
SimSickleJr<-CalculateUMAPSickleJr(SimSickleJr,modality=1)
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,title="K-means clusters: RNA modality",
                 umap.modality="W1H")
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,colorbymetadata="true_cell_type",
                 title="True Cell Type: RNA modality",legendname="True Cell Types",
                 umap.modality="W1H")
SimSickleJr<-CalculateUMAPSickleJr(SimSickleJr,modality=2)
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,title="K-means clusters: ATAC modality",umap.modality="W2H")
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,colorbymetadata="true_cell_type",
                 title="True Cell Type:ATAC modality",legendname="True Cell Types",
                 umap.modality="W2H")

NULL

#' @title The SickleJr class
#' @description Defines the SickleJr class for use with jrSiCKLSNMF. This object
#' contains all of the information required for analysis using jrSiCKLSNMF. This includes
#' count matrices, normalized matrices, graph Laplacians, hyperparameters, diagnostic plots,
#' and plots of cell clusters.
#' @slot count.matrices A list containing all of the quality controlled count matrices.
#' Note that these count matrices should not use all features and should
#' only include features that appear in at a minimum 10 cells.
#' @slot normalized.count.matrices A list that holds the normalized count matrices
#' @slot graph.laplacian.list A list of the graph Laplacians to be used for graph regularization
#' @slot rowRegularization A string that indicates the type of row regularization to
#' use. Types include "None" and "L2Norm"
#' @slot diffFunc A string that holds the name of the function used to measure the discrepancy between
#' data matrix X and WH for each modality; can be \code{"klp"} for the Poisson Kullback-Leibler divergence
#' or \code{"fr"} for the Frobenius norm
#' @slot lambdaWlist A list of lambda values to use as the hyperparameters for the
#' corresponding \eqn{\mathbf{W}^v} in the \eqn{v^{\text{th}}} modality
#' @slot lambdaH A numeric value corresponding to the hyperparameter of the sparsity constraint on \eqn{\mathbf{H}}
#' @slot Wlist A list of the generated \eqn{\mathbf{W}^v} matrices, one for each modality
#' @slot H The shared \eqn{\mathbf{H}} matrix
#' @slot WHinitials A list that if, when using \code{\link{PlotLossvsLatentFactors}}, all of the cells are used to calculate
#' the initial values, stores these initial generated matrices; can be used
#' as initializations when running \code{\link{RunjrSiCKLSNMF}} to save time
#' @slot lossCalcSubsample A vector that holds the cell indices on which \code{\link{PlotLossvsLatentFactors}} was calculated
#' @slot latent.factor.elbow.values A data frame that holds the relevant information to plot the latent factor elbow plot
#' @slot minibatch Indicator variable that states whether the algorithm should use mini-batch updates.
#' @slot clusterdiagnostics List of the cluster diagnostic results for the SickleJr object. Includes diagnostic plots from \code{\link[factoextra]{fviz_nbclust}} and
#' and diagnostics from \code{\link[clValid]{clValid}}
#' @slot clusters List of results of different clustering methods performed on the SickleJr object
#' @slot metadata List of metadata
#' @slot loss Vector of the value for the loss function
#' @slot umap List of different UMAP-based dimension reductions using \code{\link[umap]{umap}}
#' @slot plots Holds various \code{\link[ggplot2]{ggplot}} results for easy access of diagnostics and cluster visualizations
#' @returns An object of class SickleJr
#' @export
SickleJr<-methods::setClass(
  "SickleJr",
  slots=c(
    count.matrices="list",
    normalized.count.matrices="list",
    graph.laplacian.list="list",
    rowRegularization="character",
    diffFunc="character",
    lambdaWlist="list",
    lambdaH="numeric",
    Wlist="list",
    H="matrix",
    WHinitials="list",
    lossCalcSubsample="vector",
    latent.factor.elbow.values="data.frame",
    minibatch="logical",
    clusterdiagnostics="list",
    clusters="list",
    metadata="list",
    loss="vector",
    umap="list",
    plots="list"
  )
)

#' @title Create an object of class SickleJr
#' @name CreateSickleJr
#' @description Using a list of sparse count matrices, create an object of class SickleJr
#' and specify the names of these count matrices.
#' @param count.matrices A list of quality-controlled count matrices with pre-filtered features where each modality corresponds to each matrix in the
#' list
#' @param names Optional parameter with names for the count matrices in vector format
#' @returns An object of class SickleJr with sparse count matrices added to the \code{count.matrices} slot
#' @examples
#' ExampleSickleJr<-CreateSickleJr(SimData$Xmatrices)
CreateSickleJr<-function(count.matrices,names=NULL){
  if(length(names)!=length(count.matrices)){
    warning("\n Length of names does not match length of list of count matrices. Names of count matrices will remain unchanged.\n")
    names<-NULL
  }
  if(!is.null(names)){
    names(count.matrices)<-names
  }
  #Force matrix to be stored in sparse format.
  count.matrices<-lapply(count.matrices, function(x){if(!.is.sparseMatrix(x)){
    x<-.sparsify(x)
  }else{x}})
  object<-methods::new(Class="SickleJr",count.matrices=count.matrices)
  return(object)
}

#' @title Build KNN graphs and generate their graph Laplacians
#' @description Generate graph Laplacians for graph regularization of
#' jrSiCKLSNMF from the list of raw count matrices using a KNN graph. Note that this
#' is only appropriate when the number of features is considerably greater
#' than the number of cells in all modalities. If this is not the case, please use
#' \code{\link{BuildSNNGraphLaplacians}} or any other method of graph
#' construction that does not rely on the Euclidean distance and store the graph Laplacians for
#' each modality as a list in the \code{graph.laplacian.list} slot.
#' @name BuildKNNGraphLaplacians
#' @param SickleJr An object of class SickleJr
#' @param k Number of KNN neighbors to calculate; by default, is set to 20
#' @returns An object of class SickleJr with a list of graph Laplacians in sparse matrix format
#' added to the \code{graph.laplacian.list} slot
#' @references
#' \insertRef{Lun2016}{jrSiCKLSNMF}
#' @examples
#' SimSickleJrSmall<-BuildKNNGraphLaplacians(SimSickleJrSmall)
#'@export
BuildKNNGraphLaplacians<-function(SickleJr,k=20){
    counts<-SickleJr@count.matrices
    SickleJr@graph.laplacian.list<-lapply(counts,function(x){
    laplacian_matrix(makeKNNGraph(x,k=k))})
  return(SickleJr)
}

#' @title Build SNN graphs and generate their graph Laplacians
#' @description Generate graph Laplacians for graph regularization of
#' jrSiCKLSNMF from the list of raw count matrices using an SNN graph. SNN is more robust to
#' situations where the number of cells outnumbers the number of features. Uses
#' the \code{scran} package's \code{BuildSNNGraph} function \insertCite{Lun2016}{jrSiCKLSNMF}
#' @name BuildSNNGraphLaplacians
#' @param SickleJr An object of class SickleJr
#' @param k Number of KNN neighbors to calculate SNN graph; defaults to 20
#' @returns An object of class SickleJr with list of graph Laplacians in sparse
#' matrix format added to its \code{graph.laplacian.list} slot
#' @references
#' \insertRef{Lun2016}{jrSiCKLSNMF}
#' @examples
#' SimSickleJrSmall<-BuildSNNGraphLaplacians(SimSickleJrSmall)
#'@export
BuildSNNGraphLaplacians<-function(SickleJr,k=20){
    counts<-SickleJr@count.matrices
    SickleJr@graph.laplacian.list<-lapply(counts,function(x){
    laplacian_matrix(makeSNNGraph(x,k=k))})
  return(SickleJr)
}



#' @title Normalize the count matrices and set whether to use the Poisson KL divergence
#' or the Frobenius norm
#' @description Normalize the count data within each modality. The default
#' normalization, which should be used when using the KL divergence, is median
#' library size normalization \insertCite{Zheng2017,Elyanow2020}{jrSiCKLSNMF}. To perform median library size normalization,
#' each count within a cell is divided by its library size (i.e. the counts within a column are divided by the
#' column sum). Then, all values are multiplied by the median library size
#' (i.e. the median column sum). To use the Frobenius norm, set \code{frob=TRUE} to log\eqn{(x+1)}
#' normalize your count data and use a desired \code{scaleFactor}.
#' You may also use a different form of normalization and store these results
#' in the \code{normalized.count.matrices} slot.
#' @name NormalizeCountMatrices
#' @param SickleJr An object of class SickleJr
#' @param diffFunc A string set to "klp" when using the Poisson KL divergence
#'or to "fr" when using the Frobenius norm: default is KL divergence; this also determines
#'the type of normalization
#' @param scaleFactor A single numeric value (if using the same scale factor for each modality)
#' or a list of numeric values to use (if using different scale factors in different modalities)
#' as scale factors for the log\eqn{(x+1)} normalization when \code{diffFunc="fr"}
#' @returns An object of class SickleJr with a list of sparse, normalized data matrices added to its \code{normalized.count.matrices} slot
#' @references
#' \insertRef{Elyanow2020}{jrSiCKLSNMF}
#'
#' \insertRef{Zheng2017}{jrSiCKLSNMF}
#' @examples
#' SimSickleJrSmall<-NormalizeCountMatrices(SimSickleJrSmall)
#' SimSickleJrSmall<-NormalizeCountMatrices(SimSickleJrSmall, diffFunc="fr",scaleFactor=1e6)
#'@export

NormalizeCountMatrices<-function(SickleJr,diffFunc="klp",scaleFactor=NULL){
  Xmatrixlist<-SickleJr@count.matrices
  SickleJr@diffFunc<-diffFunc
  frob=FALSE
  if(diffFunc=="fr"){
    frob=TRUE
  }
  NormalizedXmatrices<-Xmatrixlist
  medianlibsize<-list()
  scaleFactorlist<-list()
  if(!frob){
    medianlibsize<-lapply(Xmatrixlist,function(x) {median(unlist(
      lapply(.listCols(x),function(y) sum(y))))})
    for(i in 1:length(Xmatrixlist)){
      normalizeXmatrixlist<-.listCols(Xmatrixlist[[i]])
      normalizeXmatrixlist<-lapply(normalizeXmatrixlist,function(x){x/sum(x)*medianlibsize[[i]]})
      NormalizedXmatrices[[i]]@x<-unlist(normalizeXmatrixlist)
    }
  } else{
    if(is.list(scaleFactor)){
      if(length(scaleFactor)==length(Xmatrixlist)){
        scaleFactorlist=scaleFactor
      } else{
        if(length(scaleFactor)==1){
          warning(paste0("\n List contains only 1 scale factor. Setting all scale factors to ",scaleFactor[[1]],".\n"))
          for(i in 1:length(Xmatrixlist)){
            scaleFactorlist[[i]]=scaleFactor[[1]]
          }
        } else{
          stop("\n Length of scale factor list not equal to number of assays\n")
        }
      }
    } else if(is.null(scaleFactor)){
      warning("\n No scale factor given. Setting to 1e6 \n")
      for(i in 1:length(Xmatrixlist)){
        scaleFactorlist[[i]]=1e6
      }
    } else if (is.numeric(scaleFactor)){
      warning(paste0("\n Only one scale factor specified. Setting all to ",scaleFactor,".\n"))
      for(i in 1:length(Xmatrixlist)){
        scaleFactorlist[[i]]=scaleFactor
      }
    } else{
      stop("\n Scale factor is not numeric or a list of proper length.\n")
    }
    for(i in 1:length(Xmatrixlist)){
      normalizeXmatrixlist<-.listCols(Xmatrixlist[[i]])
      scaleFactori=scaleFactorlist[[i]]
      normalizeXmatrixlist<-lapply(normalizeXmatrixlist,function(x){x/sum(x)*scaleFactori})
      normalizeXmatrixlist<-lapply(normalizeXmatrixlist,function(x){log(x+1)})
      NormalizedXmatrices[[i]]@x<-unlist(normalizeXmatrixlist)
    }
  }
  SickleJr@normalized.count.matrices<-NormalizedXmatrices
  return(SickleJr)
}


#' @title Set lambda values and type of row regularization for an object of class SickleJr
#' @description Provide the values for the graph regularization \eqn{\lambda_{\textbf{W}^v}}
#' for each modality as a list, provide the value for the sparsity constraint \eqn{\lambda_{\mathbf{H}}},
#' and select whether to use L2 norm regularization.
#' @name SetLambdasandRowReg
#' @param SickleJr An object of class SickleJr
#' @param lambdaWlist A list of graph regularization constraints for the \eqn{\mathbf{W}^v} matrices:
#' defaults to 2 modalities with the RNA modality constraint equal to 10 and the ATAC modality constraint equal to 50
#' @param lambdaH A numeric holding the sparsity constraint on \eqn{\mathbf{H}}: defaults to 500.
#' @param rowReg A string that is equal to \code{"None"} for no constraints on the rows of \eqn{\mathbf{H}} and \code{"L2Norm"}
#' to set the L2 norms of the rows of \eqn{\mathbf{H}} to be equal to 1: defaults to "None"
#' @returns An object of class SickleJr with the lambda hyperparameter values added to its \code{lambdaWlist} and \code{lambdaH} slots and with the
#' row regularization value added to its \code{rowRegularization} slot
#' @examples
#' SimSickleJrSmall<-SetLambdasandRowReg(SimSickleJrSmall,
#' lambdaWlist=list(10,50),lambdaH=500,rowReg="None")
#' SimSickleJrSmall<-SetLambdasandRowReg(SimSickleJrSmall,
#' lambdaWlist=list(3,15),lambdaH=0,rowReg="L2Norm")
#' @export
#'
SetLambdasandRowReg<-function(SickleJr,lambdaWlist=list(10,50),lambdaH=500,rowReg="None"){
  SickleJr@lambdaWlist<-lambdaWlist
  SickleJr@lambdaH<-lambdaH
  SickleJr@rowRegularization<-rowReg
  return(SickleJr)
}

#' @title Initialize the \eqn{\mathbf{W}} matrices in each modality and the shared \eqn{\mathbf{H}} matrix
#' @description Create the \eqn{\mathbf{W}^v} matrices and \eqn{\mathbf{H}} matrix via non-negative double singular
#' value decomposition (NNDSVD) (Boutsidis and Gallopoulus 2008; Gaujoux and Seoighe 2010)
#' or randomization. For randomization, the algorithm runs for 10 rounds
#' for the desired number of random initializations and picks the \eqn{\mathbf{W}^v} matrices and \eqn{\mathbf{H}} matrix with
#' the lowest achieved loss.
#' @name GenerateWmatricesandHmatrix
#' @param SickleJr An object of class SickleJr
#' @param d Number of latent factors to use: defaults to 10
#' @param random Boolean indicating whether to use random initialization (\code{TRUE}) or NNDSVD (\code{FALSE}): default is NNDSVD
#' @param numberReps Number of random initializations to use: default is 5
#' @param seed Random seed for reproducibility of random initializations
#' @param minibatch Indicates whether or not to use the mini-batch algorithm
#' @param batchsize Size of batches for mini-batch NMF
#' @param random_W_updates Indicates whether to only update each \eqn{\mathbf{W}^v} once per round of
#' \eqn{\mathbf{H}} updates; only appropriate for mini-batch algorithms
#' @param subsample A vector of values to use for subsampling; only appropriate
#' when determining proper values for d.
#' @param usesvd Indicates whether to use \code{R}'s singular value decomposition function
#' svd (TRUE) or irlba (FALSE), default is \code{FALSE}; use irlba for larger datasets
#' to increase performance
#' @returns SickleJr An object of class SickleJr with the \eqn{\mathbf{W}^v} matrices and \eqn{\mathbf{H}} matrix added.
#' @references
#' \insertRef{Boutsidis2008}{jrSiCKLSNMF}
#'
#' \insertRef{NMFinR}{jrSiCKLSNMF}
#' @export
#' @examples
#' SimSickleJrSmall<-SetLambdasandRowReg(SimSickleJrSmall,
#' lambdaWlist=list(10,50),lambdaH=500,rowReg="None")
#' SimSickleJrSmall<-GenerateWmatricesandHmatrix(SimSickleJrSmall,d=5,usesvd=TRUE)
#'
GenerateWmatricesandHmatrix<-function(SickleJr,d=10,random=FALSE,
                                      numberReps=100,seed=5,minibatch=FALSE,batchsize=-1,
                                      random_W_updates=FALSE,subsample=1:dim(SickleJr@count.matrices[[1]])[2],
                                      usesvd=FALSE){
  Hconcatmat<-NULL
  NormalizedXmatrices<-SickleJr@normalized.count.matrices
  if(length(subsample)<dim(SickleJr@normalized.count.matrices[[1]])[2]){
    for(i in 1:length(SickleJr@normalized.count.matrices)){
      NormalizedXmatrices[[i]]<-SickleJr@normalized.count.matrices[[i]][,subsample]
    }
  }
  rowReg=SickleJr@rowRegularization

  if(!random){
    svdlist<-lapply(NormalizedXmatrices,function(x) .nndsvd(A=x,k=d,flag=1,svd=usesvd))
    WandMeanlist<-lapply(svdlist,function(x) list(W=x$W,meanW=mean(apply(x$W,2,function(y) sum(y)))))
    SickleJr@Wlist<-lapply(WandMeanlist,function(x) apply(x$W,2,function(y) y/sum(y))*x$meanW)
    bigXmatrix<-do.call(rbind,NormalizedXmatrices)
    svdH<-.nndsvd(A=bigXmatrix,k=d,flag=1,svd=usesvd)
    Hconcatmat<-t(svdH$H)
    if(rowReg=="L2Norm"){
      norms<-apply(Hconcatmat,2,function(x)sqrt(sum(x^2)))
      for(i in 1:dim(Hconcatmat)[[2]]){
        Hconcatmat[,i]=Hconcatmat[,i]/norms[i]
      }
    } else if(rowReg=="L1Norm"){
      Hconcatmat<-apply(Hconcatmat,2,function(x)x/sum(x))
    } else{
      meanHconcat<-mean(apply(Hconcatmat,2,function(x) sum(x)))
      Hconcatmat<-apply(Hconcatmat,2,function(x) x/sum(x))*meanHconcat
    }
    SickleJr@H<-Hconcatmat
  }else{
    output<-rep(0,numberReps)
    for(i in 1:numberReps){

    set.seed(seed+i)
    Unormvals<-lapply(NormalizedXmatrices,
                      function(x) {list(normvals=median(unlist(.listCols(x))),
                      dimW=dim(x)[1])})
    Hvals<-mean(unlist(lapply(Unormvals,function(x) x$normvals)))
    Wvals<-lapply(Unormvals,function(x) {x$normvals<-x$normvals/(Hvals*sqrt(d))
                                          return(x)})
    Hvals<-Hvals/sqrt(d)
    Hdim<-dim(NormalizedXmatrices[[1]])[2]
    Wnew<-lapply(Wvals,function(x) matrix(runif(d*x$dimW,min=0,max=x$normvals),nrow = x$dimW,ncol=d))
    Hconcatmat<-matrix(runif(Hdim*d,min=0,max=Hvals),nrow=Hdim,ncol=d)
    if(rowReg=="L2Norm"){
      norms<-apply(Hconcatmat,2,function(x)sqrt(sum(x^2)))
      for(i in 1:dim(Hconcatmat)[[2]]){
        Hconcatmat[,i]=Hconcatmat[,i]/norms[i]
      }
    } else if(rowReg=="L1Norm"){
      Hconcatmat<-apply(Hconcatmat,2,function(x)x/sum(x))
    } else{
      meanHconcat<-mean(apply(Hconcatmat,2,function(x) sum(x)))
      Hconcatmat<-apply(Hconcatmat,2,function(x) x/sum(x))*meanHconcat
    }
    if(i==1){
      old.W=copy(Wnew)
      old.H=copy(Hconcatmat)
    }
    SickleJr@H<-Hconcatmat
    SickleJr@Wlist<-Wnew
    rm(Hconcatmat)
    rm(Wnew)
    SickleJr<-RunjrSiCKLSNMF(SickleJr,rounds=5,minibatch=minibatch,random_W_updates=random_W_updates,
                   batchsize=batchsize,seed=seed,display_progress = FALSE,suppress_warnings = TRUE)
    output[i]=tail(SickleJr@loss$Loss,1)
    if(which.min(output[which(output>0)])!=i){
      SickleJr@H<-copy(old.H)
      SickleJr@Wlist=copy(old.W)
    }else{
      old.H=copy(SickleJr@H)
      old.W=copy(SickleJr@Wlist)
    }
    }
  }
  return(SickleJr)
}

#' @title Create plots to help determine the number of latent factors
#' @description Generate plots of the lowest achieved loss after a
#' pre-specified number of iterations (default 100) for each latent factor
#' (defaults to 2:20). This operates similarly to a scree plot, so please select
#' a number of latent factors that corresponds to the elbow of the plot.
#' This method is not appropriate for larger sets of data (more than 1000 cells)
#' @name PlotLossvsLatentFactors
#' @param SickleJr An object of class SickleJr
#' @param rounds Number of rounds to use: defaults to 100; this process is time consuming,
#' so a high number of rounds is not recommended
#' @param differr Tolerance for the percentage update in the likelihood: for these plots,
#' this defaults to \eqn{1e-4}
#' @param d_vector Vector of \eqn{d} values to test: default is 2 to 20
#' @param parallel Boolean indicating whether to use parallel computation
#' @param nCores Number of desired cores; defaults to the number of cores of the current machine minus 1 for convenience
#' @param subsampsize Size of the random subsample (defaults to \code{NULL}, which means all cells will be used); using a random subsample decreases computation time but sacrifices accuracy
#' @param minibatch Boolean indicating whether to use the mini-batch algorithm: default is \code{FALSE}
#' @param random Boolean indicating whether to use random initialization to generate the \eqn{\mathbf{W}^v} matrices and \eqn{\mathbf{H}} matrix:
#' defaults to \code{FALSE}
#' @param random_W_updates Boolean parameter for mini-batch algorithm; if \code{TRUE}, only updates \eqn{\mathbf{W}^v} once per epoch on the
#' penultimate subset of \eqn{\mathbf{H}}; otherwise updates \eqn{\mathbf{W}^v} after every update of the subset of \eqn{\mathbf{H}}
#' @param seed Number representing the random seed
#' @param batchsize Desired batch size; do not use if using a subsample
#' @param lossonsubset Boolean indicating whether to calculate the loss on a subset rather than the full dataset; speeds up computation for larger datasets
#' @param losssubsetsize Number of cells to use for the loss subset; default is total number of cells
#' @returns An object of class SickleJr with a list of initialized \eqn{\mathbf{W}^v} matrices and an \eqn{\mathbf{H}} matrix
#' for each latent factor \eqn{d\in\{1,...,D\}} added to the \code{WHinitials} slot, a data frame holding relevant
#' values for plotting the elbow plot added to the \code{latent.factor.elbow.values} slot, diagnostic plots of the loss vs. the number of latent factors added to the \code{plots}
#' slot, and the cell indices used to calculate the loss on the subsample added to the \code{lossCalcSubSample} slot
#' @references
#' \insertRef{ggplot2}{jrSiCKLSNMF}
#' @export
#' @examples
#' SimSickleJrSmall@latent.factor.elbow.values<-data.frame(NULL,NULL)
#' SimSickleJrSmall<-PlotLossvsLatentFactors(SimSickleJrSmall,d_vector=c(2:5),
#' rounds=5,parallel=FALSE)
#' #Next, we commute 2 of these in parallel.
#' \dontrun{
#' SimSickleJrSmall<-PlotLossvsLatentFactors(SimSickleJrSmall,
#' d_vector=c(6:7),rounds=5,parallel=TRUE,nCores=2)}

PlotLossvsLatentFactors<-function(SickleJr,rounds=100,differr=1e-4,d_vector=c(2:20),
                                  parallel=FALSE,nCores=detectCores()-1,subsampsize=NULL,
                                  minibatch=FALSE,random=FALSE,random_W_updates=FALSE,seed=NULL,batchsize=-1,
                                  lossonsubset=FALSE,losssubsetsize=dim(SickleJr@count.matrices[[1]])[2]){
  latentfactors<-SickleJr@latent.factor.elbow.values$latent_factor_number
  if(any(latentfactors%in%d_vector)){
    alreadycalced<-dput(latentfactors[which(latentfactors%in%d_vector)])
      message(paste(alreadycalced,
            "has already been calculated. Skipping calculation for this value"))
    d_vector<-d_vector[-which(d_vector%in%latentfactors)]
    emptyvec<-is_empty(d_vector)
    if(emptyvec){
      latent_factor_number<-SickleJr@latent.factor.elbow.values$latent_factor_number
      Loss<-SickleJr@latent.factor.elbow.values$Loss
      elbowvals<-data.frame(latent_factor_number=latent_factor_number,Loss=Loss)
      s=""
      if(rounds>1){
        s="s"
      }
      plotvals<-ggplot(elbowvals,aes(x=latent_factor_number,y=Loss))+geom_line()+geom_point()+theme_bw()+ggtitle(paste0("Plot of Number of Latent Factors vs Loss after ",rounds," Iteration",s))+xlab("Number of Latent Factors")
      print(plotvals)
      stop("No uncalculated values for d. Plotting loss values for latent factors and exiting...\n")
    }
  }
  if(is.numeric(seed)){
    set.seed(seed)
  }
  initsamp=NULL
  if(!lossonsubset){
    initsamp=1:losssubsetsize
  }else{
    initsamp<-sample(1:dim(SickleJr@normalized.count.matrices[[1]])[2],losssubsetsize,replace=FALSE)
  }
  if(is.numeric(subsampsize)&(minibatch)){
    stop("It is not appropriate to use both the minibatch algorithm and a subsample.
         Please select only one.\n")
  }
  samp<-NULL
  if(is.null(subsampsize)){
    subsampsize=dim(SickleJr@count.matrices[[1]])[2]
    message("\n Subsample not specified. Setting to number of cells. \n")
    samp<-1:subsampsize
  } else  if(subsampsize>=dim(SickleJr@count.matrices[[1]])[2]){
    warning("\n Subsample size is greater than or equal to number of cells. Using all cells.\n")
    subsampsize=dim(SickleJr@count.matrices[[1]])[2]
    samp=1:dim(SickleJr@count.matrices[[1]])[2]
  } else if (!is.numeric(subsampsize)){
    stop("\n Subsample size is not numeric. Exiting...")
  }else {
    samp=sample(1:dim(SickleJr@count.matrices[[1]])[2],subsampsize,replace=FALSE)
  }
  if(random_W_updates & !minibatch){
    warning("\n Random W updates are only appropriate for minibatch algorithms. Setting random_W_updates to FALSE.\n" )
    random_W_updates=FALSE
  }
  if(batchsize>dim(SickleJr@count.matrices[[1]])[2]){
    warning("\n Batch size larger than number of cells. Will not use the minibatch algorithm \n")
    batchsize=-1
    minibatch=FALSE
  }
  AdjL=lapply(SickleJr@graph.laplacian.list,function(x) {x@x[which(x@x>0)]=0
  return(-x)})
  DL=lapply(SickleJr@graph.laplacian.list,function(x) {x@x[which(x@x<0)]=0
  return(x)})
  SickleJrSub<-list()
  for(i in 1:length(SickleJr@normalized.count.matrices)){
    SickleJrSub[[i]]<-SickleJr@normalized.count.matrices[[i]][,samp]
  }
  if(!minibatch){
    initsamp=1:dim(SickleJrSub[[1]])[2]
  }
  if(losssubsetsize<dim(SickleJrSub[[1]])[2]){
    initsamp<-sample(1:dim(SickleJrSub[[1]])[2],batchsize,replace=FALSE)
    #prepare initsamp for c++
    initsamp<-initsamp-1
  }else{initsamp=1:dim(SickleJrSub[[1]])[2]-1}
  WHinitials<-NULL
  lossvals<-NULL
  if(!parallel){
    cl=NULL} else{
      cl<-makeCluster(nCores)
      clusterExport(cl,varlist=c("SickleJr","d_vector","random","samp","AdjL","DL","differr","rounds","initsamp","SickleJrSub"),envir = environment())
      clusterEvalQ(cl,library("jrSiCKLSNMF"))
    }
  message("\n Calculating initial WH matrices... \n")
  WHinitials<-pblapply(X=d_vector,FUN=function(x) {newvals=GenerateWmatricesandHmatrix(SickleJr,d=x,random=random,subsample=samp)
  list(d=x,Wlist=newvals@Wlist,H=newvals@H)},cl=cl)
  message("\n Running jrSiCKLSNMF... \n")
  lossvals<-pblapply(X=WHinitials,FUN=function(x){
      vals<-jrSiCKLSNMF(datamatL=SickleJrSub,
                      WL=x[["Wlist"]],
                      H=x[["H"]],
                      AdjL=AdjL,
                      DL=DL,
                      lambdaWL=SickleJr@lambdaWlist,
                      lambdaH=SickleJr@lambdaH,
                      Hconstraint = toString(SickleJr@rowRegularization),
                      differr=differr,
                      display_progress=FALSE,
                      rounds=rounds,
                      diffFunc = toString(SickleJr@diffFunc),
                      minrounds=rounds,
                      suppress_warnings=TRUE,
                      initsamp = 1:dim(SickleJrSub[[1]])[2])
    return(vals[length(vals)])},cl=cl)
   if(parallel) {
     stopCluster(cl)
   }
    newlikelihoodvalues<-NULL
    for(i in 1:length(lossvals)){
      newlikelihoodvalues<-rbind(newlikelihoodvalues,min(lossvals[[i]]$Loss))
    }
    oldvals<-SickleJr@latent.factor.elbow.values
    SickleJr@latent.factor.elbow.values<-rbind(oldvals,data.frame(latent_factor_number=d_vector,Loss=newlikelihoodvalues))
    elbowvals=SickleJr@latent.factor.elbow.values
    plotvals<-ggplot(elbowvals,aes(x=latent_factor_number,y=Loss))+geom_line()+geom_point()+theme_bw()+ggtitle(paste0("Plot of Number of Latent Factors vs Loss after ",rounds," Iterations"))+xlab("Number of Latent Factors")
    print(plotvals)
    SickleJr@plots[["LossvsLatentFactors"]]<-plotvals
    SickleJr@WHinitials<-WHinitials
    SickleJr@lossCalcSubsample<-samp
  return(SickleJr)
}


#' @title Create elbow plots of the singular values derived from IRLBA
#' to determine D for large datasets
#' @description This generates v+1 plots, where v is the number of data modalities, of the approximate
#' singular values generated by IRLBA.There is one plot for each modality and then a
#' final plot that concatenates all of the modalities together. Choose the largest elbow
#' value among the three plots.
#' @param SickleJr An object of class SickleJr
#' @param d Number of desired factors; it is important to select a number that
#' allows you to see a clear elbow: defaults to 50.
#' @returns An object of class SickleJr with plots for IRLBA diagnostics added to its \code{plots} slot
#' @references
#' \insertRef{irlba}{jrSiCKLSNMF}
#' @export
#' @examples
#' \dontrun{SimSickleJrSmall<-DetermineDFromIRLBA(SimSickleJrSmall,d=5)}
DetermineDFromIRLBA<-function(SickleJr,d=50){

  modalitylabels<-names(SickleJr@normalized.count.matrices)
  modalitylabels<-c(modalitylabels,"Concatenated")
  concatmat<-do.call("rbind",SickleJr@normalized.count.matrices)
  normcounts<-SickleJr@normalized.count.matrices
  normcounts[[length(normcounts)+1]]<-concatmat
  message("Calculating IRLBA for all data matrices")
  IRLBAlist<-pblapply(normcounts,function(x) irlba(x,nv=d))
  message("Preparing data for plotting")
  Singular_values=NULL
  Index=NULL
  dataframelist<-pblapply(IRLBAlist,function(x){Index=c(1:length(x$d))
    Singular_values=x$d
    data.frame(Index,Singular_values)})
  for(i in 1:length(dataframelist)){
    dataframelist[[i]]<-cbind(dataframelist[[i]],Name=rep(modalitylabels[i],length(dataframelist[[i]][,1])))
  }
  message("Generating Plots")
  ggplots<-pblapply(dataframelist,function(x) ggplot<-ggplot(x,aes(Index,Singular_values))+geom_point()+geom_line()+ggtitle(paste0("Index vs. Singular Value for ",x$Name[1]," Data"))+theme_bw()+ylab("Singular Value")+xlab("Index of Singular Value"))
  lapply(ggplots,FUN=function(x) print(x))
  SickleJr@plots[["DiagnosticIRLBA"]]<-ggplots
  return(SickleJr)
}

#' @title Set \eqn{\mathbf{W}} matrices and \eqn{\mathbf{H}} matrix from pre-calculated values
#' @description
#' Use values calculated in the step to determine number of latent factors in the initial
#' steps for the jrSiCKLSNMF algorithm. If only a subset was calculated, this produces an error.
#' In this case, please use \code{\link{GenerateWmatricesandHmatrix}} to generate new
#' \eqn{\mathbf{W}^v} matrices and a new \eqn{\mathbf{H}} matrix.
#' @param SickleJr An object of class SickleJr
#' @param d The number of desired latent factors
#' @returns An object of class SickleJr with the \code{Wlist} slot and the \code{H} slot filled from pre-calculated values.
#' @examples SimSickleJrSmall<-SetWandHfromWHinitials(SimSickleJrSmall,d=5)
#' @export
#'
SetWandHfromWHinitials<-function(SickleJr,d){
  numcells<-dim(SickleJr@normalized.count.matrices[[1]])[2]
  numcellsinit<-dim(SickleJr@WHinitials[[1]][["H"]])[1]
  latent_factor_number=SickleJr@latent.factor.elbow.values$latent_factor_number
  if(!(d%in%latent_factor_number)){
    stop("\n Initial values for W and H and have not been calculated for the specified number of latent factors. Exiting...\n")
  }
  whichd<-which(unlist(lapply(SickleJr@WHinitials,function(x) x[["d"]]==d)))
  listwh<-copy(SickleJr@WHinitials[[whichd]])

  if(numcells!=numcellsinit){
    stop("\n Number of total cells differs from number of cells used in calculation for the initial plot. Use 'GenerateWMatricesandHmatrix' to generate the initial matrices. \n")
  } else{
    SickleJr@Wlist<-SickleJr@WHinitials[[whichd]][["Wlist"]]
    SickleJr@H<-SickleJr@WHinitials[[whichd]][["H"]]}
  return(SickleJr)
}

#' @title Run jrSiCKLSNMF on an object of class SickleJr
#' @description Wrapper function to run jrSiCKLSNMF on an object of class SickleJr. Performs jrSiCKLSNMF on
#' the given SickleJr
#' @name RunjrSiCKLSNMF
#' @param SickleJr An object of class SickleJr
#' @param rounds Number of rounds: defaults to 2000
#' @param differr Tolerance for percentage change in loss between updates: defaults to 1e-6
#' @param display_progress Boolean indicating whether to display the progress bar for jrSiCKLSNMF
#' @param lossonsubset Boolean indicating whether to use a subset to calculate the loss function
#' rather than the whole dataset
#' @param losssubsetsize Size of the subset of data on which to calculate the loss
#' @param minibatch Boolean indicating whether to use mini-batch updates
#' @param batchsize Size of batch for mini-batch updates
#' @param random_W_updates Boolean indicating whether or not to use random_W_updates updates
#' (i.e. only update \eqn{\mathbf{W}^v} once per mini-batch epoch)
#' @param seed Number specifying desired random seed
#' @param minrounds Minimum number of rounds: most helpful for the mini-batch algorithm
#' @param suppress_warnings Boolean indicating whether to suppress warnings
#' @param subsample A numeric used primarily when finding an appropriate number of
#' latent factors: defaults to total number of cells
#' @returns An object of class SickleJr with updated \eqn{\mathbf{W}^v} matrices, updated \eqn{\mathbf{H}} matrix, and a vector of values for
#' the loss function added to the \code{Wlist}, \code{H}, and \code{loss} slots, respectively
#' @references
#' \insertRef{Cai2008}{jrSiCKLSNMF}
#'
#' \insertRef{jnmf2009}{jrSiCKLSNMF}
#'
#' \insertRef{Eddelbuettel2011}{jrSiCKLSNMF}
#'
#' \insertRef{Eddelbuettel2014}{jrSiCKLSNMF}
#'
#' \insertRef{Elyanow2020}{jrSiCKLSNMF}
#'
#' \insertRef{halfbakednmf}{jrSiCKLSNMF}
#'
#' \insertRef{Lee1999}{jrSiCKLSNMF}
#'
#' \insertRef{Liu2013}{jrSiCKLSNMF}
#'
#' @examples \dontrun{SimSickleJrSmall<-RunjrSiCKLSNMF(SimSickleJrSmall,rounds=5)}
#' @export
RunjrSiCKLSNMF<-function(SickleJr,rounds=30000,differr=1e-6,
                         display_progress=TRUE,lossonsubset=FALSE,losssubsetsize=dim(SickleJr@H)[1],
                         minibatch=FALSE,batchsize=1000,random_W_updates=FALSE,seed=NULL,minrounds=200,
                         suppress_warnings=FALSE,subsample=1:dim(SickleJr@normalized.count.matrices[[1]])[2]){
  SickleJr@minibatch<-FALSE
  if(minibatch){
    SickleJr@minibatch<-TRUE
  }
  if(is.numeric(seed)){
    set.seed(seed)
  }
  initsamp=NULL
  if(!lossonsubset){
    if(losssubsetsize!=dim(SickleJr@H)[1]){
      warning("\n Using a subset to calculate the loss was set to FALSE while the size of the subset for the loss was not equal to the number of cells. Setting the loss subset to the total number of cells... \n")
    }
    losssubsetsize=dim(SickleJr@H)[1]
  }
  if(losssubsetsize<dim(SickleJr@H)[1]){
    initsamp<-sample(1:dim(SickleJr@normalized.count.matrices[[1]])[2],losssubsetsize,replace=FALSE)
    #prepare initsamp for c++
    initsamp<-initsamp-1
  }else{initsamp=1:dim(SickleJr@H)[1]-1}
  AdjL=lapply(SickleJr@graph.laplacian.list,function(x) {x@x[which(x@x>0)]=0
                                                          return(-x)})
  DL=lapply(SickleJr@graph.laplacian.list,function(x) {x@x[which(x@x<0)]=0
                                                        return(x)})
  usemats<-lapply(SickleJr@normalized.count.matrices,function(x) x[,subsample])
  outputloss<-jrSiCKLSNMF(datamatL=usemats,
                          WL=SickleJr@Wlist,H=SickleJr@H,
                          AdjL=AdjL,
                          DL=DL,
                          lambdaWL=SickleJr@lambdaWlist,
                          lambdaH=SickleJr@lambdaH,
                          Hconstraint=toString(SickleJr@rowRegularization),
                          differr=differr,
                          display_progress = display_progress,
                          rounds=rounds,
                          diffFunc=SickleJr@diffFunc,
                          minibatch=minibatch,
                          batchsize=batchsize,
                          initsamp=initsamp,
                          random_W_updates=random_W_updates,
                          minrounds=minrounds,
                          suppress_warnings=suppress_warnings)
  SickleJr@loss<-outputloss
  return(SickleJr)
}

#' @title Plot a diagnostic plot for the mini-batch algorithm
#' @description To ensure sufficient convergence of the loss for jrSiCKLSNMF with mini-batch updates, we
#' plot the loss vs the number of iterations for the mini-batch algorithm.
#' After a certain number of iterations, the loss should appear to oscillate
#' around a value. Before continuing with downstream analyses, please ensure that
#' the loss exhibits this sort of behavior. For the mini-batch algorithm, it is not
#' possible to use the convergence criteria used for the batch version of the
#' algorithm.
#' @param SickleJr An object of class SickleJr
#' @returns An object of class SickleJr with mini-batch diagnostic plots added to the \code{plots} slot.
#' @examples SimSickleJrSmall<-MinibatchDiagnosticPlot(SimSickleJrSmall)
#' @export

MinibatchDiagnosticPlot<-function(SickleJr){
  if(!SickleJr@minibatch){
    warning("\n This is not a mini-batch algorithm, so this plot won't give you particularly helpful diagnostics.")
  }
  niterations<-4:length(SickleJr@loss$Loss)
  loss<-SickleJr@loss$Loss[-c(1:3)]
  lossdata<-data.frame(niterations=niterations,loss=loss)
  g<-ggplot(lossdata,aes(x=niterations,y=loss))+geom_line()+theme_bw()+ggtitle("Plot of Loss vs. Number of Iterations")+xlab("Number of Iterations")+ylab("Loss")
  print(g)
  SickleJr@plots[["Mini-batch_Diagnostics"]]<-g
}

#' @title Perform clustering diagnostics
#' @description
#' A wrapper for the \code{\link[clValid]{clValid}} and \code{\link[factoextra]{fviz_nbclust}} functions to perform clustering diagnostics
#' @param SickleJr An object of class SickleJr
#' @param numclusts A vector of integers indicating the number of clusters to test
#' @param clusteringmethod String holding the clustering method: defaults to k-means; since the other methods
#' are not implemented in jrSiCKLSNMF, it is recommended to use k-means.
#' @param diagnosticmethods Vector of strings indicating which methods to plot. Defaults to all three of the available: wss, silhouette, and gap_stat
#' @param clValidvalidation String containing validation method to use for \code{clValid}. Defaults to internal.
#' @param createDiagnosticplots Boolean indicating whether to create diagnostic plots for cluster size
#' @param runclValidDiagnostics Boolean indicating whether to calculate the diagnostics from \code{clValid}
#' @param printPlots Boolean indicating whether to print the diagnostic plots
#' @param printclValid Boolean indicating whether to print the diagnostic results from \code{clValid}
#' @param subset Boolean indicating whether to calculate the diagnostics on a subset of the data rather
#' than on the whole dataset.
#' @param subsetsize Numeric value indicating size of the subset
#' @param seed Numeric value holding the random seed
#' @references
#' \insertRef{clValid}{jrSiCKLSNMF}
#'
#' \insertRef{factoextra}{jrSiCKLSNMF}
#' @returns An object of class SickleJr with cluster diagnostics added to its \code{clusterdiagnostics} slot
#' @examples #Since these data are too small, the clValid diagnostics do not run
#' #properly. See the vignette for an example with the clValid diagnostics
#' SimSickleJrSmall<-DetermineClusters(SimSickleJrSmall,numclusts=2:5,runclValidDiagnostics=FALSE)
#' @export
DetermineClusters<-function(SickleJr,numclusts=2:20,clusteringmethod="kmeans",
                            diagnosticmethods=c("wss","silhouette","gap_stat"),
                            clValidvalidation="internal",createDiagnosticplots=TRUE,
                            runclValidDiagnostics=TRUE,printPlots=TRUE,
                            printclValid=TRUE,
                            subset=FALSE,subsetsize=1000,
                            seed=NULL){

  ingraph<-FALSE
  inclValid<-FALSE
  if((clusteringmethod%in% c("kmeans","clara","fanny","dbscan","Mclust","HCPC","hkmeans"))&
     !(clusteringmethod%in% c("hierarchical","kmeans","diana","fanny","som","model","sota","pam","clara","agnes"))){
    warning("\n This clustering method is not available in clValid. Only graphs will be printed and saved in the clusterdiagnostics slot.\n")
    ingraph<-TRUE
    }else if(!(clusteringmethod%in% c("kmeans","clara","fanny","dbscan","Mclust","HCPC","hkmeans"))&
           (clusteringmethod%in% c("hierarchical","kmeans","diana","fanny","som","model","sota","pam","clara","agnes"))){
      warning("\n This clustering method is not available in factoextra. Only information from clValid will be printed and saved in the clusterdiagnostics slot.\n")
      inclValid<-TRUE
  }else if ((clusteringmethod%in% c("kmeans","clara","fanny","dbscan","Mclust","HCPC","hkmeans"))&
            (clusteringmethod%in% c("hierarchical","kmeans","diana","fanny","som","model","sota","pam","clara","agnes"))){
    ingraph<-TRUE
    inclValid<-TRUE
  }else{
    stop("\n Valid clustering method not selected. Please select a valid clustering method. Options include:\n 'kmeans','clara','fanny','dbscan','Mclust',HCPC','hkmeans','hierarchical','diana','som','model','pam',and 'agnes'.")
  }
  ggplotlist<-list()
  rownames(SickleJr@H)<-colnames(SickleJr@count.matrices[[1]])
  clValidobj<-NULL
  Hrun<-NULL
  if(subset&subsetsize>dim(SickleJr@H)[1]){
    warning("Size of subset is greater than the number of cells. Using full dataset")
    subset=FALSE
  }
  if(subset){
    if(is.numeric(seed)){
      set.seed(seed)
    }
    subset<-sample(1:dim(SickleJr@H)[1],subsetsize,replace = FALSE)
    Hrun<-SickleJr@H[subset,]
  }else{
    Hrun<-SickleJr@H
  }
  if(!createDiagnosticplots){
    ingraph=FALSE
  }
  if(ingraph){
    ggplotlist<-lapply(diagnosticmethods,function(x) fviz_nbclust(Hrun,match.fun(clusteringmethod),method=x,k.max=max(numclusts)))
    if(printPlots){
      lapply(ggplotlist,function(x) print(x))
    }
  }
  if(!runclValidDiagnostics){
    inclValid<-FALSE
  }
  if(inclValid){
    clValidobj<-clValid(Hrun,clMethods=clusteringmethod,validation=clValidvalidation,nClust=numclusts)
    if(printclValid){
      print(summary(clValidobj))
    }
  }
  SickleJr@clusterdiagnostics<-list(DiagnosticPlots=ggplotlist,clValidResults=clValidobj)
  return(SickleJr)
}

#' @title Cluster the \eqn{\mathbf{H}} matrix
#' @description Perform k-means, spectral clustering, clustering based off of the
#' index of the maximum latent factor, or Louvain community detection on the \eqn{\mathbf{H}} matrix.
#' Defaults to k-means.
#' @name ClusterSickleJr
#' @param SickleJr An object of class SickleJr
#' @param numclusts Number of clusters; can be NULL when method is "max" or "louvain"
#' @param method String holding the clustering method: can choose "kmeans" for
#' k-means clustering, "spectral" for spectral clustering, "louvain" for Louvain
#' community detection or "max" for clustering based on the maximum row value; note that
#' "max" is only appropriate for jrSiCKLSNMF with L2 norm row regularization
#' @param neighbors Number indicating the number of neighbors to use to generate the
#' graphs for spectral clustering and Louvain community detection: both of these
#' methods require the construction of a graph first (here we use KNN);
#' defaults to 20 and unused when the clustering method equal to "kmeans" or "max"
#' @param louvainres Numeric containing the resolution parameter for Louvain
#' community detection; unused for all other methods
#' @examples SimSickleJrSmall<-ClusterSickleJr(SimSickleJrSmall,3)
#' SimSickleJrSmall<-ClusterSickleJr(SimSickleJrSmall,method="louvain",neighbors=5)
#' SimSickleJrSmall<-ClusterSickleJr(SimSickleJrSmall,method="spectral",neighbors=5,numclusts=3)
#' #DO NOT DO THIS FOR REAL DATA; this is just to illustrate max clustering
#' SimSickleJrSmall<-SetLambdasandRowReg(SimSickleJrSmall,rowReg="L2Norm")
#' SimSickleJrSmall<-ClusterSickleJr(SimSickleJrSmall,method="max")
#' @references
#' \insertRef{louvain}{jrSiCKLSNMF}
#'
#' \insertRef{Lun2016}{jrSiCKLSNMF}
#'
#' \insertRef{Ng2001}{jrSiCKLSNMF}
#'
#' \insertRef{Schliep2016}{jrSiCKLSNMF}
#'
#' \insertRef{maxcluster}{jrSiCKLSNMF}
#' @returns SickleJr- an object of class SickleJr with added clustering information
#' @export
ClusterSickleJr<-function(SickleJr,numclusts,method="kmeans",neighbors=20,louvainres=0.3){
  clust<-NULL
  if(method=="kmeans"){
   clust<-kmeans(SickleJr@H,centers=numclusts,nstart=1000)$cluster
  }else if(method=="spectral"){
    clust<-specClust(SickleJr@H,centers=numclusts,nn=neighbors)$cluster
  }else if(method=="louvain"){
    knngraph<-makeKNNGraph(SickleJr@H,k=neighbors)
    newvals<-cluster_louvain(knngraph,resolution = louvainres)
    clust<-newvals$membership
  }else if(method=="max"){
    if(SickleJr@rowRegularization!="L2Norm"){
      stop("\n Clustering based off the maximum latent factor per observation is not appropriate for H matrices that do not utilize the 'L2Norm' constraint\n")
    }
    clust<-apply(SickleJr@H,1,function(x) which.max(x))
    }else {print("Please enter 'kmeans' for k-means clustering, 'spectral' for spectral clustering,
                'louvain' for Louvain community detection or 'max' to cluster based on
                the maximum latent factor for each observation. Please note that 'max'
                is only appropriate for the L2Norm-based variant.")}
  SickleJr@clusters[[method]]<-clust
  return(SickleJr)
}


#' @title Calculate the UMAP for an object of class SickleJr
#' @description Perform UMAP on the \eqn{\mathbf{H}} matrix alone (default) or within a modality by
#' using UMAP on the \eqn{W^vH} corresponding to modality \eqn{v}.
#' @name CalculateUMAPSickleJr
#' @param SickleJr An object of class SickleJr
#' @param umap.settings Optional settings for the \code{\link[umap]{umap}}; defaults to \code{\link[umap]{umap.defaults}}
#' @param modality A number corresponding to the desired modality; if set, will perform UMAP on
#' \eqn{\mathbf{W}^{\mathtt{modality}}}%*%t(\eqn{\mathbf{H}}) rather than
#' on \eqn{\mathbf{H}} alone; not recommended for datasets of more than 1000 cells
#' @returns An object of class SickleJr with UMAP output based on the \eqn{\mathbf{H}} matrix alone or within a modality added to its \code{umap} slot
#' @references
#' \insertRef{UMAP}{jrSiCKLSNMF}
#' @examples
#' #Since this example has only 10 observations,
#' #we need to modify the number of neighbors from the default of 15
#' umap.settings=umap::umap.defaults
#' umap.settings$n_neighbors=2
#' SimSickleJrSmall<-CalculateUMAPSickleJr(SimSickleJrSmall,
#' umap.settings=umap.settings)
#' SimSickleJrSmall<-CalculateUMAPSickleJr(SimSickleJrSmall,
#' umap.settings=umap.settings,modality=1)
#' SimSickleJrSmall<-CalculateUMAPSickleJr(SimSickleJrSmall,
#' umap.settings=umap.settings,modality=2)
#' @export
CalculateUMAPSickleJr<-function(SickleJr,umap.settings=umap::umap.defaults,modality=NULL){
  if(!is.null(modality)){
    WH<-t(SickleJr@Wlist[[modality]]%*%t(SickleJr@H))
    WHname<-paste0("W",modality,"H")
    SickleJr@umap[[WHname]]<-umap::umap(WH,config=umap.settings)
  }else{
    SickleJr@umap[["H"]]<-umap::umap(SickleJr@H,config=umap.settings)
  }
  return(SickleJr)
}

#' @title Add metadata to an object of class SickleJr
#' @description Add any type of metadata to an object of class SickleJr. Metadata
#' are stored in list format under the name specified in \code{metadataname} of each node in slot \code{metadata}.
#' @name AddSickleJrMetadata
#' @param SickleJr An object of class SickleJr holding at least one count matrix of omics data
#' @param metadata Metadata to add to the SickleJr object; there are no restrictions on type
#' @param metadataname A string input that indicates the desired name for the added
#' metadata.
#' @returns An object of class SickleJr with added metadata
#' @examples SimSickleJrSmall<-AddSickleJrMetadata(SimSickleJrSmall,
#' SimData$cell_type,"cell_types_full_data")
#' @export
AddSickleJrMetadata<-function(SickleJr,metadata,metadataname){
  SickleJr@metadata[[metadataname]]<-metadata
  return(SickleJr)
}

#' @title Generate UMAP plots for an object of class SickleJr
#' @description Plot the first and second dimensions of a UMAP dimension reduction
#' and color either by clustering results or metadata.
#' @name PlotSickleJrUMAP
#' @param SickleJr An object of class SickleJr
#' @param umap.modality String corresponding to the name of the UMAP of interest: defaults to \code{"H"}
#' @param cluster String input that indicates which cluster to color by: defaults to \code{"kmeans"}
#' @param title String input for optional \code{\link[ggplot2:ggplot]{ggplot}} plot title
#' @param colorbymetadata Name of metadata column if coloring by metadata
#' @param legendname String input that to allow specification of a different legend name
#' @returns An object of class SickleJr with plots added to the \code{plots} slot
#' @references
#' \insertRef{ggplot2}{jrSiCKLSNMF}
#' @examples SimSickleJrSmall<-PlotSickleJrUMAP(SimSickleJrSmall,
#' title="K-Means Example")
#' SimSickleJrSmall<-PlotSickleJrUMAP(SimSickleJrSmall,umap.modality=1)
#' @export
PlotSickleJrUMAP<-function(SickleJr,umap.modality="H",cluster="kmeans",title="",colorbymetadata=NULL,legendname=NULL){
  if(is.null(colorbymetadata)){
    color=SickleJr@clusters[[cluster]]
    if(is.null(legendname)){
      legendname=paste(cluster, "cluster")
      }

  }else{
    color=SickleJr@metadata[[colorbymetadata]]
    if(is.null(legendname)){legendname=colorbymetadata}
    cluster=colorbymetadata
  }
  UMAP1=SickleJr@umap[[umap.modality]]$layout[,1]
  UMAP2=SickleJr@umap[[umap.modality]]$layout[,2]
  umapvals<-data.frame(UMAP1=UMAP1,UMAP2=UMAP2,cluster=color)
  plots<-ggplot(umapvals,aes(x=UMAP1,y=UMAP2,color=factor(color)))+geom_point()+theme_bw()+
    ggtitle(title)+guides(color=guide_legend(title=legendname))
  SickleJr@plots[[paste0(umap.modality,":",cluster)]]<-plots
  print(plots)
  return(SickleJr)
}

NULL
#' A simulated dataset for use with jrSiCKLSNMF
#' @description A simulated dataset with \eqn{\mathcal{U}(1,1.25)} multiplicative noise for the
#' scRNA-seq variability parameter in SPARSim for the simulated scRNA-seq data and
#' with \eqn{\mathcal{N}(-0.25,0.25)} additive noise to the expression levels of the scATAC-seq data
#' for data simulated via SimATAC. The simulated matrices are located in SimData$Xmatrices
#' and the identities for the cell types are contained in SimData$cell_type. This corresponds
#' to the Xmatrix data found in both
#'
#' XandLmatrices25/XandindividLKNNLmatrices1Sparsity5.RData and
#'
#' XandBulkLmatrix25/XandBulkLKNNmatrices1Sparsity5.RData on our Github
#'
#' \href{https://github.com/ellisdoro/jrSiCKLSNMF_Simulations}{ellisdoro/jrSiCKLSNMF_Simulations}
#'
#' @docType data
#'
#' @usage data(SimData)
#'
#' @format A list made up of a two items. The first is list of 2 simulated sparse matrices
#' and the second is a vector containing cell identities.
#' \describe{
#' \item{Xmatrices}{A list of 2 sparse matrices, each containing a different
#' simulated omics modality measured on the same set of single cells: the first entry in the list
#' corresponds to simulated scRNA-seq data and has 1000 genes and 300 cells; the second entry in
#' the list corresponds to simulated scATAC-seq data and has 5910 peaks and 300
#' cells.}
#' \item{cell_type}{A vector containing the cell-type identities of the simulated data}}
#' @keywords datasets
#' @source \href{https://github.com/ellisdoro/jrSiCKLSNMF_Simulations}{jrSicKLSNMF Simulations}
#'
"SimData"

#' A small SickleJr object containing a subset of data from the
#' \verb{SimData} data object. Contains the completed analysis from the
#' `Getting Started` vignette for a small subset of 10 cells with 150 genes and
#' 700 peaks. The clusters derived from this dataset are not accurate; this dataset
#' is intended for use with code examples.
#'
#' @docType data
#'
#' @usage data(SimSickleJrSmall)
#'
#' @format A SickleJr object containing a completed analysis using jrSiCKLSNMF
#' \describe{
#' \item{count.matrices}{Contains a list of 2 sparse matrices, each containing a different
#' simulated omics modality measured on the same set of single cells}
#' \item{normalized.count.matrices}{The normalized versions of the count matrices
#' contained in slot \code{count.matrices}}
#' \item{graph.laplacian.list}{A list of sparse matrices containing the graph
#' Laplacians corresponding to the KNN feature-feature similarity graphs constructed
#' for each omics modality}
#' \item{rowRegularization}{A string indicating the row regularization: here it
#' is set to \code{"None"}}
#' \item{diffFunc}{A string specifying the function to measure the discrepancy
#' between the normalized data and the fitted matrices: here, it is set to "klp"
#' for the Poisson Kullback-Leibler divergence}
#' \item{lambdaWlist}{A list holding the graph regularization parameters: here,
#' they are 10 and 50}
#' \item{lambdaH}{A numeric indicating the value for the sparsity parameter.
#' Here it is equals 500}
#' \item{Wlist}{A list holding the fitted \eqn{\mathbf{W}^v} matrices}
#' \item{H}{A matrix holding \eqn{\mathbf{H}}}
#' \item{WHinitials}{A list of initial values for \eqn{\mathbf{W}^v} and \eqn{\mathbf{H}}}
#' \item{lossCalcSubsample}{A vector containing a subset on which to calculate the loss}
#' \item{latent.factor.elbow.values}{A data frame holding the loss and the number of latent factor that is used for diagnostic plots}
#' \item{minibatch}{A Boolean indicating whether or not to use the mini-batch algorithm: \code{FALSE} here}
#' \item{clusterdiagnostics}{Diagnostic plots and results}
#' \item{clusters}{A list holding the \code{"kmeans"} clustering results}
#' \item{metadata}{A list holding metadata; here this is just cell type information}
#' \item{loss}{A list holding a vector called "Loss"}
#' \item{umap}{A list holding various UMAP approximations}
#' \item{plots}{A list holding ggplots corresponding to different diagnostics and visualizations}
#' }
#' @keywords datasets
#' @source \href{https://github.com/ellisdoro/jrSiCKLSNMF_Simulations}{jrSicKLSNMF Simulations}
"SimSickleJrSmall"

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----loadjrSiCKLSNMF----------------------------------------------------------
library(jrSiCKLSNMF)

DataMatrices<-SimData$Xmatrices
cell_type<-SimData$cell_type
SimSickleJr<-CreateSickleJr(DataMatrices,names=list("RNA","ATAC"))
rm(DataMatrices,SimData)
SimSickleJr<-AddSickleJrMetadata(SimSickleJr,cell_type,"true_cell_type")
rm(cell_type)
set.seed(10)
SimSickleJr<-BuildKNNGraphLaplacians(SimSickleJr)
SimSickleJr<-SetLambdasandRowReg(SimSickleJr,lambdaWlist=list(10,50),lambdaH=500,rowReg="None")
SimSickleJr<-NormalizeCountMatrices(SimSickleJr)

## ----irlba--------------------------------------------------------------------
SimSickleJr<-DetermineDFromIRLBA(SimSickleJr)
SimSickleJr<-GenerateWmatricesandHmatrix(SimSickleJr,d=5)

## ----runningjrsickls----------------------------------------------------------
start.time<-Sys.time()
SimSickleJr<-RunjrSiCKLSNMF(SimSickleJr,rounds=200,differr=1e-6,minibatch=TRUE,random_W_updates=TRUE,batchsize=100,seed=8,minrounds = 200)
stop.time<-Sys.time()
stop.time-start.time

## ----minibatchplotdiagnostic--------------------------------------------------
MinibatchDiagnosticPlot(SimSickleJr)

## ----determineclustering------------------------------------------------------
SimSickleJr<-DetermineClusters(SimSickleJr,printclValid = FALSE)

## ----clustering---------------------------------------------------------------
SimSickleJr<-ClusterSickleJr(SimSickleJr,numclusts=4)

## ----UMAPplots----------------------------------------------------------------
SimSickleJr<-CalculateUMAPSickleJr(SimSickleJr)
#Plotting based off of cluster
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,title="K-means clusters")


## ----clustering2--------------------------------------------------------------
SimSickleJr<-ClusterSickleJr(SimSickleJr,numclusts=3)

## ----UMAPplots2---------------------------------------------------------------
#Plotting based off of cluster
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,title="K-means clusters")
#Plotting based off of true cell type metadata
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,colorbymetadata="true_cell_type",title="True Cell Types",legendname="True Cell Types")

## ----UMAPplotsWH--------------------------------------------------------------
SimSickleJr<-CalculateUMAPSickleJr(SimSickleJr,modality=1)
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,title="K-means clusters: RNA modality",
                 umap.modality="W1H")
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,colorbymetadata="true_cell_type",
                 title="True Cell Type: RNA modality",legendname="True Cell Types",
                 umap.modality="W1H")
SimSickleJr<-CalculateUMAPSickleJr(SimSickleJr,modality=2)
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,title="K-means clusters: ATAC modality",umap.modality="W2H")
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,colorbymetadata="true_cell_type",
                 title="True Cell Type:ATAC modality",legendname="True Cell Types",
                 umap.modality="W2H")

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' @title Run jrSiCKLSNMF outside of a SickleJr object
#' @description Perform joint non-negative matrix factorization (NMF) across multiple modalities of single-cell data.
#' To measure the discrepancy between two distributions, one can use the Poisson Kullback-Leibler divergence (\eqn{\mathtt{diffFunc}=}\eqn{\mathtt{"klp"}})  or the Frobenius norm (\eqn{\mathtt{diffFunc}=}\eqn{\mathtt{"fr"}}).
#' It is also possible to set graph regularization constraints on \eqn{\mathbf{W}^v} and either a sparsity constraint on \eqn{\mathbf{H}} or an
#' L2 norm constraint on the rows of \eqn{\mathbf{H}}.
#' This function passes by reference and updates the variables \eqn{\mathtt{WL}} and \eqn{\mathtt{H}} and does not require data to be in an
#' object of type SickleJr. \eqn{\mathtt{RunjrSiCKLSNMF}} calls this function. If your data are in an object of class SickleJr,
#' please use the \eqn{\mathtt{RunjrSiCKLSNMF}} function instead.
#' @name jrSiCKLSNMF
#' @param datamatL An R list where each entry contains a normalized, sparse \eqn{\mathbf{X}^v} matrix corresponding to single-cell modality \eqn{v}
#' @param WL An R list containing initialized values of the \eqn{\mathbf{W}^v} within each modality \eqn{v}
#' @param H A matrix containing initialized values for the shared \eqn{\mathbf{H}}
#' @param AdjL An R list containing all of the adjacency matrices for the
#' feature-feature similarity graphs in sparse format; note that \eqn{\mathtt{D-Adj}} is the
#' graph Laplacian
#' @param DL An R list containing all of the degree matrices of the
#' feature-feature similarity graphs; note that \eqn{\mathtt{D-Adj}} is the graph Laplacian
#' @param lambdaWL A list of the \eqn{\lambda_{\mathbf{W}^v}} corresponding to modality \eqn{v}
#' @param lambdaH A double containing the desired value for \eqn{\lambda_{\mathbf{H}}}
#' @param initsamp A vector of randomly selected rows of \eqn{\mathtt{H}} on which to run the objective function
#' @param suppress_warnings A Boolean that indicates whether warnings should be suppressed
#' @param diffFunc A string indicating what type of divergence to use; set to the Poisson Kullback-Leibler divergence
#' (\eqn{\mathtt{``klp"}}) by default, but the Frobenius norm (\eqn{\mathtt{``fr"}}) is also available
#' @param Hconstraint A string that indicates whether you want to set an L2 norm constraint on the rows of \eqn{\mathbf{H}}. Enter `None` for
#' no constraints or `L2Norm` to set the L2 norm of each row of \eqn{\mathbf{H}} to 1
#' @param differr A double containing the tolerance
#' @param rounds A double containing the number of rounds
#' @param display_progress A Boolean indicating whether to display the progress bar
#' @param minibatch A Boolean indicating whether to use the mini-batch version of the algorithm
#' @param batchsize Number of batches for mini-batch updates
#' @param random_W_updates A Boolean indicating whether to update \eqn{\mathbf{W}^v} once per epoch (TRUE) or after every update of
#' the subset of \eqn{\mathbf{H}} (FALSE) for the mini-batch algorithm.
#' @param minrounds A minimum number of rounds for the algorithm to run: most useful for the mini-batch algorithm
#' @returns An R list containing values for the objective function.
#' @references
#' \insertRef{Cai2008}{jrSiCKLSNMF}
#'
#' \insertRef{jnmf2009}{jrSiCKLSNMF}
#'
#' \insertRef{Eddelbuettel2011}{jrSiCKLSNMF}
#'
#' \insertRef{Eddelbuettel2014}{jrSiCKLSNMF}
#'
#' \insertRef{Elyanow2020}{jrSiCKLSNMF}
#'
#' \insertRef{halfbakednmf}{jrSiCKLSNMF}
#'
#' \insertRef{Lee1999}{jrSiCKLSNMF}
#'
#' \insertRef{Liu2013}{jrSiCKLSNMF}
#'
#' @export
jrSiCKLSNMF <- function(datamatL, WL, H, AdjL, DL, lambdaWL, lambdaH, initsamp, suppress_warnings, diffFunc = "klp", Hconstraint = "None", differr = 1e-6, rounds = 1000L, display_progress = TRUE, minibatch = TRUE, batchsize = 100L, random_W_updates = TRUE, minrounds = 100L) {
    .Call(`_jrSiCKLSNMF_jrSiCKLSNMF`, datamatL, WL, H, AdjL, DL, lambdaWL, lambdaH, initsamp, suppress_warnings, diffFunc, Hconstraint, differr, rounds, display_progress, minibatch, batchsize, random_W_updates, minrounds)
}

###% The following functions (.pos, .neg,.norm,.nndsvd) are from the NMF R package
###% (Gaujoux and Seoighe, 2010). These functions are hidden in the NMF package
##% (hence they have been copied here rather than pulled from the NMF package)
##% and were in turn adapted from Boutsidis and Gallopoulos (2008)
###% Seeding method: Nonnegative Double Singular Value Decomposition
###%
###% @author Renaud Gaujoux
###% @creation 17 Jul 2009


###% Auxliary functions

# .pos extracts all of the positive values from a matrix. This code is taken from the R package NMF
.pos <- function(x){ as.numeric(x>=0) * x }


# .neg extracts all of the negative values from a matrix. This code is taken from the NMF R package

.neg <- function(x){ - as.numeric(x<0) * x }


#.norm takes the Frobenius norm of a non-negative matrix. This code is taken from the NMF R package
.norm <- function(x){ sqrt(drop(crossprod(x))) }


#nnsvd performs non-negative double singular value decomposition This code is taken from the
#NMF R package and is a port to R of the MATLAB code from Boutsidis and Gallopoulos (2008).
.nndsvd <- function(A, k, flag=0,svd=FALSE){

  #check the input matrix
  if( any(A<0) ) stop('The input matrix contains negative elements !')

  #size of input matrix
  size = dim(A);
  m <- size[1]; n<- size[2]

  #the matrices of the factorization
  W = matrix(0, m, k);
  H = matrix(0, k, n);

  #1st SVD --> partial SVD rank-k to the input matrix A.
  if(svd){
  s = svd(A, k, k);
  U <- s$u; S <- s$d; V <- s$v
  }else{
    s=irlba(A,nv=k)
    U<-s$u; S<-s$d; V<-s$v
  }

  #-------------------------------------------------------
  # We also recommend the use of propack for the SVD
  # 1st SVD --> partial SVD rank-k ( propack )
  # OPTIONS.tol  = 0.00001;               % remove comment to this line
  # [U,S,X] = LANSVD(A,k,'L',OPTIONS);    % remove comment to this line
  #-------------------------------------------------------

  #choose the first singular triplet to be nonnegative
  W[,1] = sqrt(S[1]) * abs(U[,1]);
  H[1,] = sqrt(S[1]) * abs(t(V[,1]));

  # second SVD for the other factors (see table 1 in Boutsidis' paper)
  for( i in seq(2,k) ){
    uu = U[,i]; vv = V[,i];
    uup = .pos(uu); uun = .neg(uu) ;
    vvp = .pos(vv); vvn = .neg(vv);
    n_uup = .norm(uup);
    n_vvp = .norm(vvp) ;
    n_uun = .norm(uun) ;
    n_vvn = .norm(vvn) ;
    termp = n_uup %*% n_vvp; termn = n_uun %*% n_vvn;
    if (termp >= termn){
      W[,i] = sqrt(S[i] * as.vector(termp)) * uup / n_uup;
      H[i,] = sqrt(S[i] * as.vector(termp)) * vvp / n_vvp;
    }else{
      W[,i] = sqrt(S[i] * as.vector(termn)) * uun / n_uun;
      H[i,] = sqrt(S[i] * as.vector(termn)) * vvn / n_vvn;
    }
  }

  #------------------------------------------------------------

  #actually these numbers are zeros
  W[W<0.0000000001] <- 0;
  H[H<0.0000000001] <- 0;

  if( flag==1 ){ #NNDSVDa: fill in the zero elements with the average

    ind1 <- W==0 ;
    ind2 <- H==0 ;
    average <- mean(A);
    W[ind1] <- average;
    H[ind2] <- average;

  }else if( flag==2  ){#NNDSVDar: fill in the zero elements with random values in the space :[0:average/100]

    ind1 <- W==0;
    ind2 <- H==0;
    n1 <- sum(ind1);
    n2 <- sum(ind2);

    average = mean(A);
    W[ind1] =  (average * runif(n1, min=0, max=1) / 100);
    H[ind2] =  (average * runif(n2, min=0, max=1) / 100);

  }

  # return matrices W and H
  list(W=W, H=H)
}
#A function that tests whether a matrix is sparse
.is.sparseMatrix <- function(x) is(x, 'sparseMatrix')
#a function that sparsifies the matrices in all of the lists
.sparsify<-function(denselist){
  sparselist<-lapply(denselist,function(x) as(x,"sparseMatrix"))
  return(sparselist)
}
#List the columns of sparse matrices
.listCols<-function(m){
  res<-split(m@x,findInterval(seq_len(nnzero(m)),m@p,left.open=TRUE))
  names(res)<-colnames(m)
  res
}
#List the rows of sparse matrices
.listRows<-function(m){
  mt<-t(m)
  res<-split(mt@x,findInterval(seq_len(nnzero(mt)),mt@p,left.open=TRUE))
  names(res)<-colnames(mt)
  res
}

---
title: "Mini-batch jrSiCKLSNMF Tutorial"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Mini-batch jrSiCKLSNMF Tutorial}
  %\VignetteEngine{knitr::rmarkdown}
  %\usepackage[UTF-8]{inputenc}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Set up
For this walkthrough, we will be working with simulated data object SimData. These data were generated from GSE130399 using the packages SparSim and simATAC. The details for the simulations can be found in our paper. SimData has already gone through quality control (QC); however, when working with real data, you should QC your data and select features that appear in at least 10 cells for both modalities. After loading jrSiCKLSNMF into R, you should have access to SimData.

Here, we set up our data as in the getting started and getting started L2 Norm vignettes. Please refer to these for details on setup.

```{r loadjrSiCKLSNMF}
library(jrSiCKLSNMF)

DataMatrices<-SimData$Xmatrices
cell_type<-SimData$cell_type
SimSickleJr<-CreateSickleJr(DataMatrices,names=list("RNA","ATAC"))
rm(DataMatrices,SimData)
SimSickleJr<-AddSickleJrMetadata(SimSickleJr,cell_type,"true_cell_type")
rm(cell_type)
set.seed(10)
SimSickleJr<-BuildKNNGraphLaplacians(SimSickleJr)
SimSickleJr<-SetLambdasandRowReg(SimSickleJr,lambdaWlist=list(10,50),lambdaH=500,rowReg="None")
SimSickleJr<-NormalizeCountMatrices(SimSickleJr)
```
Next, we will determine the number of latent factors by using IRLBA. By looking at all three
plots generated, we see that 5 appears to correspond to a value close to the elbow for all modalities and for 
the concatenated modality.
```{r irlba}
SimSickleJr<-DetermineDFromIRLBA(SimSickleJr)
SimSickleJr<-GenerateWmatricesandHmatrix(SimSickleJr,d=5)
```


# Running mini-batch jrSiCKLSNMF

Finally, we can run mini-batch jrSicKLSNMF. Please note that we store $\textbf{H}$ as $\textbf{H}^T$.  Note that because the mini-batch algorithm is stochastic, it has a higher convergence tolerance. Therefore, please specify the number of rounds in the "minrounds" variable.

```{r runningjrsickls}
start.time<-Sys.time()
SimSickleJr<-RunjrSiCKLSNMF(SimSickleJr,rounds=200,differr=1e-6,minibatch=TRUE,random_W_updates=TRUE,batchsize=100,seed=8,minrounds = 200)
stop.time<-Sys.time()
stop.time-start.time
```
# Mini-batch Diagnostic Plots

For the mini-batch algorithm, since it is a stochastic process, the loss tends to become unstable after a certain number of iterations but stays within a band. To ensure that you have reached this point of stability, you should check the plot of the loss. For this plot, we can see that the loss remains relatively stable after about 200 iterations.

```{r minibatchplotdiagnostic}
MinibatchDiagnosticPlot(SimSickleJr)
```

# Post-hoc Analyses

After this, we can perform diagnostics to determine an appropriate number of cell clusters. 

```{r determineclustering}
SimSickleJr<-DetermineClusters(SimSickleJr,printclValid = FALSE)
```

We see that around 4 is an appropriate number of clusters.

```{r clustering}
SimSickleJr<-ClusterSickleJr(SimSickleJr,numclusts=4)
```

Finally, we can calculate and then plot the UMAP of our SickleJr. Note that if you would like to plot the UMAP of the compressed $\mathbf{W}^v\mathbf{H}$ matrix, please enter the number corresponding to the modality you wish to see. 
```{r UMAPplots}
SimSickleJr<-CalculateUMAPSickleJr(SimSickleJr)
#Plotting based off of cluster
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,title="K-means clusters")

```

After looking at the UMAP plots, we can see that perhaps 3 is a more appropriate number of clusters.

```{r clustering2}
SimSickleJr<-ClusterSickleJr(SimSickleJr,numclusts=3)
```

We re-plot our results with 3 clusters. Additionally, for the plots, you can either color based off of identified cluster or based off of metadata. 

```{r UMAPplots2}
#Plotting based off of cluster
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,title="K-means clusters")
#Plotting based off of true cell type metadata
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,colorbymetadata="true_cell_type",title="True Cell Types",legendname="True Cell Types")
```

We can also visualize data in the RNA modality and the ATAC modality. This is not recommended for large datasets.

```{r UMAPplotsWH}
SimSickleJr<-CalculateUMAPSickleJr(SimSickleJr,modality=1)
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,title="K-means clusters: RNA modality",
                 umap.modality="W1H")
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,colorbymetadata="true_cell_type",
                 title="True Cell Type: RNA modality",legendname="True Cell Types",
                 umap.modality="W1H")
SimSickleJr<-CalculateUMAPSickleJr(SimSickleJr,modality=2)
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,title="K-means clusters: ATAC modality",umap.modality="W2H")
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,colorbymetadata="true_cell_type",
                 title="True Cell Type:ATAC modality",legendname="True Cell Types",
                 umap.modality="W2H")
```

---
title: "Getting started with jrSiCKLSNMF"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Getting started with jrSiCKLSNMF}
  %\VignetteEngine{knitr::rmarkdown}
  %\usepackage[UTF-8]{inputenc}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Loading jrSiCKLSNMF and Creating a SickleJr Object
Here, we will provide a walkthrough of jrSiCKLSNMF on simulated data. First, install and load the jrSiCKLSNMF package:

```{r loadjrSiCKLSNMF}
library(jrSiCKLSNMF)
```

For this walkthrough, we will be working with simulated data object SimData. These data were generated from GSE130399 using the packages SparSim and simATAC. The details for the simulations can be found in our paper. SimData has already gone through quality control (QC); however, when working with real data, you should QC your data and select features that appear in at least 10 cells for both modalities. After loading jrSiCKLSNMF into R, you should have access to SimData.

Now, we create a SickleJr object. This object will hold all of the results and intermediary steps for jrSiCKLSNMF. We will also create a vector containing the cell types for the simulated data for use in the next section.

```{r createSickleJr}
SimData<-jrSiCKLSNMF::SimData
DataMatrices<-SimData$Xmatrices
cell_type<-SimData$cell_type
SimSickleJr<-CreateSickleJr(DataMatrices)
rm(DataMatrices,SimData)
```

# Adding Metadata

Next, we will add metadata in the form of the true cell identity to the SickleJr object.

```{r addmetadata}
SimSickleJr<-AddSickleJrMetadata(SimSickleJr,cell_type,"true_cell_type")
rm(cell_type)
```

You can add any metadata to the SickleJr object. Make sure to set the variable metadata to the variable containing the metadata you wish to add and the metadataname to a string containing what you wish the metadata to be called. Here, we call the metadata "true_cell_type." 
# Generation of Graph Laplacians for Graph Regularization

Next, we build our KNN graphs and extract the graph Laplacian to use for graph regularization. Note that for large matrices, this can take some time. Please set a seed if you want to have the exact same graph Laplacians every time.

```{r graphlaplacian}
set.seed(10)
SimSickleJr<-BuildKNNGraphLaplacians(SimSickleJr)
```

# Normalization, Initialization of W and H, and Setting Lambda Values

For values $\lambda_{W^v}$ and our value $\lambda_H$, when we constrain the rows of $\textbf{H}$ such that the L2 Norm of each row is equal to 1 (the default), we suggest setting $\lambda_{\textbf W^{RNA}}=3$, $\lambda_{\textbf W^{ATAC}}=15$, and $\lambda_{\textbf H}=0$. When not using this constraint, we suggest using $\lambda_{\textbf W^{RNA}}=10$, $\lambda_{W^{ATAC}}=50$, and $\lambda_{H}=500$. 

```{r setlambdas}
SimSickleJr<-SetLambdasandRowReg(SimSickleJr,lambdaWlist=list(10,50),lambdaH=500,rowReg="None")
```

Next, we will normalize our count matrices using median library size normalization.

```{r Normalize}
SimSickleJr<-NormalizeCountMatrices(SimSickleJr)
```

Now we can make plots to determine an ideal number of latent factors. Here, 5 or 6 appears to be an ideal number of
latent factors. Note that this does change depending on the initialization of the graph matrices and the seed for the number of initial samples; however, the ideal number appears to be between 4 and 7. To more accurately identify an ideal number of latent factors, perform more rounds. This is the opposite behavior of the  L2 Norm regularized version.

Also note that you should use run this in parallel, for more iterations, and over more d values. Default is 2 to 20 d values. and 200 iterations

```{r determineD}
SimSickleJr<-PlotLossvsLatentFactors(SimSickleJr,d_vector=4:6,parallel = FALSE,rounds=25)
```
In this toy example, around 5 latent factors appears to be a good value. If you already have an idea of the number of latent factors you would like to use, you may generate the H and W matrices as below:

```{r initializeWH}
SimSickleJr<-GenerateWmatricesandHmatrix(SimSickleJr,d=10)
```

However, since we already calculated part of the W matrices and the shared H matrix for all cells, 
we can use the previously calculated values to run jrSiCKLSNMF.

```{r usepreviouslycalculated}
SimSickleJr<-SetWandHfromWHinitials(SimSickleJr,d=5)
```

# Running jrSiCKLSNMF

Finally, we can run jrSicKLSNMF. By default, we constrain the rows of $\textbf{H}$ such that the L2 Norm of each row is equal to 1. Please note that we store $\textbf{H}$ as $\textbf{H}^T$. Please note that, for real data, you should use enough rounds to reach convergence of $10^{-6}$.

```{r runningjrsickls}
start.time<-Sys.time()
SimSickleJr<-RunjrSiCKLSNMF(SimSickleJr,rounds=1000,differr=1e-5,minibatch=FALSE)
stop.time<-Sys.time()
(time<-stop.time-start.time)
```
# Post-hoc Analyses

After this, we can perform cell clustering. In version 1.0, users can use k-means or spectral clustering. Here, we demonstrate k-means. We can first determine an optimal number of clusters using the fviz_nbclust function from the library factoextra and clValid from package clValid. From the plots and diagnostics, we can see that 3 appears to be the optimal number of clusters.

```{r clustering}
SimSickleJr<-DetermineClusters(SimSickleJr,printclValid=FALSE)
SimSickleJr<-ClusterSickleJr(SimSickleJr,numclusts=3)
```

Finally, we can calculate and then plot the UMAP of our SickleJr. Note that if you would like to plot the UMAP of the compressed $\mathbf{W}^v\mathbf{H}$ matrix, please enter the number corresponding to the modality you wish to see. For the plots, you can either color based off of identified cluster or based off of metadata.

```{r UMAPplots}
SimSickleJr<-CalculateUMAPSickleJr(SimSickleJr)
#Plotting based off of cluster
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,title="K-means clusters")
#Plotting based off of true cell type metadata
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,colorbymetadata="true_cell_type",title="True Cell Types",legendname="True Cell Types")
```

We can also visualize data in the RNA modality and the ATAC modality. 

```{r UMAPplotsWH}
SimSickleJr<-CalculateUMAPSickleJr(SimSickleJr,modality=1)
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,title="K-means clusters: RNA modality",
                 umap.modality="W1H")
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,colorbymetadata="true_cell_type",
                 title="True Cell Type: RNA modality",legendname="True Cell Types",
                 umap.modality="W1H")
SimSickleJr<-CalculateUMAPSickleJr(SimSickleJr,modality=2)
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,title="K-means clusters: ATAC modality",umap.modality="W2H")
SimSickleJr<-PlotSickleJrUMAP(SimSickleJr,colorbymetadata="true_cell_type",
                 title="True Cell Type:ATAC modality",legendname="True Cell Types",
                 umap.modality="W2H")
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Data.R
\docType{data}
\name{SimData}
\alias{SimData}
\title{A simulated dataset for use with jrSiCKLSNMF}
\format{
A list made up of a two items. The first is list of 2 simulated sparse matrices
and the second is a vector containing cell identities.
\describe{
\item{Xmatrices}{A list of 2 sparse matrices, each containing a different
simulated omics modality measured on the same set of single cells: the first entry in the list
corresponds to simulated scRNA-seq data and has 1000 genes and 300 cells; the second entry in
the list corresponds to simulated scATAC-seq data and has 5910 peaks and 300
cells.}
\item{cell_type}{A vector containing the cell-type identities of the simulated data}}
}
\source{
\href{https://github.com/ellisdoro/jrSiCKLSNMF_Simulations}{jrSicKLSNMF Simulations}
}
\usage{
data(SimData)
}
\description{
A simulated dataset with \eqn{\mathcal{U}(1,1.25)} multiplicative noise for the
scRNA-seq variability parameter in SPARSim for the simulated scRNA-seq data and
with \eqn{\mathcal{N}(-0.25,0.25)} additive noise to the expression levels of the scATAC-seq data
for data simulated via SimATAC. The simulated matrices are located in SimData$Xmatrices
and the identities for the cell types are contained in SimData$cell_type. This corresponds
to the Xmatrix data found in both

XandLmatrices25/XandindividLKNNLmatrices1Sparsity5.RData and

XandBulkLmatrix25/XandBulkLKNNmatrices1Sparsity5.RData on our Github

\href{https://github.com/ellisdoro/jrSiCKLSNMF_Simulations}{ellisdoro/jrSiCKLSNMF_Simulations}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Data.R
\docType{data}
\name{SimSickleJrSmall}
\alias{SimSickleJrSmall}
\title{A small SickleJr object containing a subset of data from the
\verb{SimData} data object. Contains the completed analysis from the
`Getting Started` vignette for a small subset of 10 cells with 150 genes and
700 peaks. The clusters derived from this dataset are not accurate; this dataset
is intended for use with code examples.}
\format{
A SickleJr object containing a completed analysis using jrSiCKLSNMF
\describe{
\item{count.matrices}{Contains a list of 2 sparse matrices, each containing a different
simulated omics modality measured on the same set of single cells}
\item{normalized.count.matrices}{The normalized versions of the count matrices
contained in slot \code{count.matrices}}
\item{graph.laplacian.list}{A list of sparse matrices containing the graph
Laplacians corresponding to the KNN feature-feature similarity graphs constructed
for each omics modality}
\item{rowRegularization}{A string indicating the row regularization: here it
is set to \code{"None"}}
\item{diffFunc}{A string specifying the function to measure the discrepancy
between the normalized data and the fitted matrices: here, it is set to "klp"
for the Poisson Kullback-Leibler divergence}
\item{lambdaWlist}{A list holding the graph regularization parameters: here,
they are 10 and 50}
\item{lambdaH}{A numeric indicating the value for the sparsity parameter.
Here it is equals 500}
\item{Wlist}{A list holding the fitted \eqn{\mathbf{W}^v} matrices}
\item{H}{A matrix holding \eqn{\mathbf{H}}}
\item{WHinitials}{A list of initial values for \eqn{\mathbf{W}^v} and \eqn{\mathbf{H}}}
\item{lossCalcSubsample}{A vector containing a subset on which to calculate the loss}
\item{latent.factor.elbow.values}{A data frame holding the loss and the number of latent factor that is used for diagnostic plots}
\item{minibatch}{A Boolean indicating whether or not to use the mini-batch algorithm: \code{FALSE} here}
\item{clusterdiagnostics}{Diagnostic plots and results}
\item{clusters}{A list holding the \code{"kmeans"} clustering results}
\item{metadata}{A list holding metadata; here this is just cell type information}
\item{loss}{A list holding a vector called "Loss"}
\item{umap}{A list holding various UMAP approximations}
\item{plots}{A list holding ggplots corresponding to different diagnostics and visualizations}
}
}
\source{
\href{https://github.com/ellisdoro/jrSiCKLSNMF_Simulations}{jrSicKLSNMF Simulations}
}
\usage{
data(SimSickleJrSmall)
}
\description{
A small SickleJr object containing a subset of data from the
\verb{SimData} data object. Contains the completed analysis from the
`Getting Started` vignette for a small subset of 10 cells with 150 genes and
700 peaks. The clusters derived from this dataset are not accurate; this dataset
is intended for use with code examples.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{GenerateWmatricesandHmatrix}
\alias{GenerateWmatricesandHmatrix}
\title{Initialize the \eqn{\mathbf{W}} matrices in each modality and the shared \eqn{\mathbf{H}} matrix}
\usage{
GenerateWmatricesandHmatrix(
  SickleJr,
  d = 10,
  random = FALSE,
  numberReps = 100,
  seed = 5,
  minibatch = FALSE,
  batchsize = -1,
  random_W_updates = FALSE,
  subsample = 1:dim(SickleJr@count.matrices[[1]])[2],
  usesvd = FALSE
)
}
\arguments{
\item{SickleJr}{An object of class SickleJr}

\item{d}{Number of latent factors to use: defaults to 10}

\item{random}{Boolean indicating whether to use random initialization (\code{TRUE}) or NNDSVD (\code{FALSE}): default is NNDSVD}

\item{numberReps}{Number of random initializations to use: default is 5}

\item{seed}{Random seed for reproducibility of random initializations}

\item{minibatch}{Indicates whether or not to use the mini-batch algorithm}

\item{batchsize}{Size of batches for mini-batch NMF}

\item{random_W_updates}{Indicates whether to only update each \eqn{\mathbf{W}^v} once per round of
\eqn{\mathbf{H}} updates; only appropriate for mini-batch algorithms}

\item{subsample}{A vector of values to use for subsampling; only appropriate
when determining proper values for d.}

\item{usesvd}{Indicates whether to use \code{R}'s singular value decomposition function
svd (TRUE) or irlba (FALSE), default is \code{FALSE}; use irlba for larger datasets
to increase performance}
}
\value{
SickleJr An object of class SickleJr with the \eqn{\mathbf{W}^v} matrices and \eqn{\mathbf{H}} matrix added.
}
\description{
Create the \eqn{\mathbf{W}^v} matrices and \eqn{\mathbf{H}} matrix via non-negative double singular
value decomposition (NNDSVD) (Boutsidis and Gallopoulus 2008; Gaujoux and Seoighe 2010)
or randomization. For randomization, the algorithm runs for 10 rounds
for the desired number of random initializations and picks the \eqn{\mathbf{W}^v} matrices and \eqn{\mathbf{H}} matrix with
the lowest achieved loss.
}
\examples{
SimSickleJrSmall<-SetLambdasandRowReg(SimSickleJrSmall,
lambdaWlist=list(10,50),lambdaH=500,rowReg="None")
SimSickleJrSmall<-GenerateWmatricesandHmatrix(SimSickleJrSmall,d=5,usesvd=TRUE)

}
\references{
\insertRef{Boutsidis2008}{jrSiCKLSNMF}

\insertRef{NMFinR}{jrSiCKLSNMF}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{ClusterSickleJr}
\alias{ClusterSickleJr}
\title{Cluster the \eqn{\mathbf{H}} matrix}
\usage{
ClusterSickleJr(
  SickleJr,
  numclusts,
  method = "kmeans",
  neighbors = 20,
  louvainres = 0.3
)
}
\arguments{
\item{SickleJr}{An object of class SickleJr}

\item{numclusts}{Number of clusters; can be NULL when method is "max" or "louvain"}

\item{method}{String holding the clustering method: can choose "kmeans" for
k-means clustering, "spectral" for spectral clustering, "louvain" for Louvain
community detection or "max" for clustering based on the maximum row value; note that
"max" is only appropriate for jrSiCKLSNMF with L2 norm row regularization}

\item{neighbors}{Number indicating the number of neighbors to use to generate the
graphs for spectral clustering and Louvain community detection: both of these
methods require the construction of a graph first (here we use KNN);
defaults to 20 and unused when the clustering method equal to "kmeans" or "max"}

\item{louvainres}{Numeric containing the resolution parameter for Louvain
community detection; unused for all other methods}
}
\value{
SickleJr- an object of class SickleJr with added clustering information
}
\description{
Perform k-means, spectral clustering, clustering based off of the
index of the maximum latent factor, or Louvain community detection on the \eqn{\mathbf{H}} matrix.
Defaults to k-means.
}
\examples{
SimSickleJrSmall<-ClusterSickleJr(SimSickleJrSmall,3)
SimSickleJrSmall<-ClusterSickleJr(SimSickleJrSmall,method="louvain",neighbors=5)
SimSickleJrSmall<-ClusterSickleJr(SimSickleJrSmall,method="spectral",neighbors=5,numclusts=3)
#DO NOT DO THIS FOR REAL DATA; this is just to illustrate max clustering
SimSickleJrSmall<-SetLambdasandRowReg(SimSickleJrSmall,rowReg="L2Norm")
SimSickleJrSmall<-ClusterSickleJr(SimSickleJrSmall,method="max")
}
\references{
\insertRef{louvain}{jrSiCKLSNMF}

\insertRef{Lun2016}{jrSiCKLSNMF}

\insertRef{Ng2001}{jrSiCKLSNMF}

\insertRef{Schliep2016}{jrSiCKLSNMF}

\insertRef{maxcluster}{jrSiCKLSNMF}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{RunjrSiCKLSNMF}
\alias{RunjrSiCKLSNMF}
\title{Run jrSiCKLSNMF on an object of class SickleJr}
\usage{
RunjrSiCKLSNMF(
  SickleJr,
  rounds = 30000,
  differr = 1e-06,
  display_progress = TRUE,
  lossonsubset = FALSE,
  losssubsetsize = dim(SickleJr@H)[1],
  minibatch = FALSE,
  batchsize = 1000,
  random_W_updates = FALSE,
  seed = NULL,
  minrounds = 200,
  suppress_warnings = FALSE,
  subsample = 1:dim(SickleJr@normalized.count.matrices[[1]])[2]
)
}
\arguments{
\item{SickleJr}{An object of class SickleJr}

\item{rounds}{Number of rounds: defaults to 2000}

\item{differr}{Tolerance for percentage change in loss between updates: defaults to 1e-6}

\item{display_progress}{Boolean indicating whether to display the progress bar for jrSiCKLSNMF}

\item{lossonsubset}{Boolean indicating whether to use a subset to calculate the loss function
rather than the whole dataset}

\item{losssubsetsize}{Size of the subset of data on which to calculate the loss}

\item{minibatch}{Boolean indicating whether to use mini-batch updates}

\item{batchsize}{Size of batch for mini-batch updates}

\item{random_W_updates}{Boolean indicating whether or not to use random_W_updates updates
(i.e. only update \eqn{\mathbf{W}^v} once per mini-batch epoch)}

\item{seed}{Number specifying desired random seed}

\item{minrounds}{Minimum number of rounds: most helpful for the mini-batch algorithm}

\item{suppress_warnings}{Boolean indicating whether to suppress warnings}

\item{subsample}{A numeric used primarily when finding an appropriate number of
latent factors: defaults to total number of cells}
}
\value{
An object of class SickleJr with updated \eqn{\mathbf{W}^v} matrices, updated \eqn{\mathbf{H}} matrix, and a vector of values for
the loss function added to the \code{Wlist}, \code{H}, and \code{loss} slots, respectively
}
\description{
Wrapper function to run jrSiCKLSNMF on an object of class SickleJr. Performs jrSiCKLSNMF on
the given SickleJr
}
\examples{
\dontrun{SimSickleJrSmall<-RunjrSiCKLSNMF(SimSickleJrSmall,rounds=5)}
}
\references{
\insertRef{Cai2008}{jrSiCKLSNMF}

\insertRef{jnmf2009}{jrSiCKLSNMF}

\insertRef{Eddelbuettel2011}{jrSiCKLSNMF}

\insertRef{Eddelbuettel2014}{jrSiCKLSNMF}

\insertRef{Elyanow2020}{jrSiCKLSNMF}

\insertRef{halfbakednmf}{jrSiCKLSNMF}

\insertRef{Lee1999}{jrSiCKLSNMF}

\insertRef{Liu2013}{jrSiCKLSNMF}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{NormalizeCountMatrices}
\alias{NormalizeCountMatrices}
\title{Normalize the count matrices and set whether to use the Poisson KL divergence
or the Frobenius norm}
\usage{
NormalizeCountMatrices(SickleJr, diffFunc = "klp", scaleFactor = NULL)
}
\arguments{
\item{SickleJr}{An object of class SickleJr}

\item{diffFunc}{A string set to "klp" when using the Poisson KL divergence
or to "fr" when using the Frobenius norm: default is KL divergence; this also determines
the type of normalization}

\item{scaleFactor}{A single numeric value (if using the same scale factor for each modality)
or a list of numeric values to use (if using different scale factors in different modalities)
as scale factors for the log\eqn{(x+1)} normalization when \code{diffFunc="fr"}}
}
\value{
An object of class SickleJr with a list of sparse, normalized data matrices added to its \code{normalized.count.matrices} slot
}
\description{
Normalize the count data within each modality. The default
normalization, which should be used when using the KL divergence, is median
library size normalization \insertCite{Zheng2017,Elyanow2020}{jrSiCKLSNMF}. To perform median library size normalization,
each count within a cell is divided by its library size (i.e. the counts within a column are divided by the
column sum). Then, all values are multiplied by the median library size
(i.e. the median column sum). To use the Frobenius norm, set \code{frob=TRUE} to log\eqn{(x+1)}
normalize your count data and use a desired \code{scaleFactor}.
You may also use a different form of normalization and store these results
in the \code{normalized.count.matrices} slot.
}
\examples{
SimSickleJrSmall<-NormalizeCountMatrices(SimSickleJrSmall)
SimSickleJrSmall<-NormalizeCountMatrices(SimSickleJrSmall, diffFunc="fr",scaleFactor=1e6)
}
\references{
\insertRef{Elyanow2020}{jrSiCKLSNMF}

\insertRef{Zheng2017}{jrSiCKLSNMF}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{MinibatchDiagnosticPlot}
\alias{MinibatchDiagnosticPlot}
\title{Plot a diagnostic plot for the mini-batch algorithm}
\usage{
MinibatchDiagnosticPlot(SickleJr)
}
\arguments{
\item{SickleJr}{An object of class SickleJr}
}
\value{
An object of class SickleJr with mini-batch diagnostic plots added to the \code{plots} slot.
}
\description{
To ensure sufficient convergence of the loss for jrSiCKLSNMF with mini-batch updates, we
plot the loss vs the number of iterations for the mini-batch algorithm.
After a certain number of iterations, the loss should appear to oscillate
around a value. Before continuing with downstream analyses, please ensure that
the loss exhibits this sort of behavior. For the mini-batch algorithm, it is not
possible to use the convergence criteria used for the batch version of the
algorithm.
}
\examples{
SimSickleJrSmall<-MinibatchDiagnosticPlot(SimSickleJrSmall)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{CalculateUMAPSickleJr}
\alias{CalculateUMAPSickleJr}
\title{Calculate the UMAP for an object of class SickleJr}
\usage{
CalculateUMAPSickleJr(
  SickleJr,
  umap.settings = umap::umap.defaults,
  modality = NULL
)
}
\arguments{
\item{SickleJr}{An object of class SickleJr}

\item{umap.settings}{Optional settings for the \code{\link[umap]{umap}}; defaults to \code{\link[umap]{umap.defaults}}}

\item{modality}{A number corresponding to the desired modality; if set, will perform UMAP on
\eqn{\mathbf{W}^{\mathtt{modality}}}%*%t(\eqn{\mathbf{H}}) rather than
on \eqn{\mathbf{H}} alone; not recommended for datasets of more than 1000 cells}
}
\value{
An object of class SickleJr with UMAP output based on the \eqn{\mathbf{H}} matrix alone or within a modality added to its \code{umap} slot
}
\description{
Perform UMAP on the \eqn{\mathbf{H}} matrix alone (default) or within a modality by
using UMAP on the \eqn{W^vH} corresponding to modality \eqn{v}.
}
\examples{
#Since this example has only 10 observations,
#we need to modify the number of neighbors from the default of 15
umap.settings=umap::umap.defaults
umap.settings$n_neighbors=2
SimSickleJrSmall<-CalculateUMAPSickleJr(SimSickleJrSmall,
umap.settings=umap.settings)
SimSickleJrSmall<-CalculateUMAPSickleJr(SimSickleJrSmall,
umap.settings=umap.settings,modality=1)
SimSickleJrSmall<-CalculateUMAPSickleJr(SimSickleJrSmall,
umap.settings=umap.settings,modality=2)
}
\references{
\insertRef{UMAP}{jrSiCKLSNMF}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{DetermineDFromIRLBA}
\alias{DetermineDFromIRLBA}
\title{Create elbow plots of the singular values derived from IRLBA
to determine D for large datasets}
\usage{
DetermineDFromIRLBA(SickleJr, d = 50)
}
\arguments{
\item{SickleJr}{An object of class SickleJr}

\item{d}{Number of desired factors; it is important to select a number that
allows you to see a clear elbow: defaults to 50.}
}
\value{
An object of class SickleJr with plots for IRLBA diagnostics added to its \code{plots} slot
}
\description{
This generates v+1 plots, where v is the number of data modalities, of the approximate
singular values generated by IRLBA.There is one plot for each modality and then a
final plot that concatenates all of the modalities together. Choose the largest elbow
value among the three plots.
}
\examples{
\dontrun{SimSickleJrSmall<-DetermineDFromIRLBA(SimSickleJrSmall,d=5)}
}
\references{
\insertRef{irlba}{jrSiCKLSNMF}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{DetermineClusters}
\alias{DetermineClusters}
\title{Perform clustering diagnostics}
\usage{
DetermineClusters(
  SickleJr,
  numclusts = 2:20,
  clusteringmethod = "kmeans",
  diagnosticmethods = c("wss", "silhouette", "gap_stat"),
  clValidvalidation = "internal",
  createDiagnosticplots = TRUE,
  runclValidDiagnostics = TRUE,
  printPlots = TRUE,
  printclValid = TRUE,
  subset = FALSE,
  subsetsize = 1000,
  seed = NULL
)
}
\arguments{
\item{SickleJr}{An object of class SickleJr}

\item{numclusts}{A vector of integers indicating the number of clusters to test}

\item{clusteringmethod}{String holding the clustering method: defaults to k-means; since the other methods
are not implemented in jrSiCKLSNMF, it is recommended to use k-means.}

\item{diagnosticmethods}{Vector of strings indicating which methods to plot. Defaults to all three of the available: wss, silhouette, and gap_stat}

\item{clValidvalidation}{String containing validation method to use for \code{clValid}. Defaults to internal.}

\item{createDiagnosticplots}{Boolean indicating whether to create diagnostic plots for cluster size}

\item{runclValidDiagnostics}{Boolean indicating whether to calculate the diagnostics from \code{clValid}}

\item{printPlots}{Boolean indicating whether to print the diagnostic plots}

\item{printclValid}{Boolean indicating whether to print the diagnostic results from \code{clValid}}

\item{subset}{Boolean indicating whether to calculate the diagnostics on a subset of the data rather
than on the whole dataset.}

\item{subsetsize}{Numeric value indicating size of the subset}

\item{seed}{Numeric value holding the random seed}
}
\value{
An object of class SickleJr with cluster diagnostics added to its \code{clusterdiagnostics} slot
}
\description{
A wrapper for the \code{\link[clValid]{clValid}} and \code{\link[factoextra]{fviz_nbclust}} functions to perform clustering diagnostics
}
\examples{
#Since these data are too small, the clValid diagnostics do not run
#properly. See the vignette for an example with the clValid diagnostics
SimSickleJrSmall<-DetermineClusters(SimSickleJrSmall,numclusts=2:5,runclValidDiagnostics=FALSE)
}
\references{
\insertRef{clValid}{jrSiCKLSNMF}

\insertRef{factoextra}{jrSiCKLSNMF}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{BuildSNNGraphLaplacians}
\alias{BuildSNNGraphLaplacians}
\title{Build SNN graphs and generate their graph Laplacians}
\usage{
BuildSNNGraphLaplacians(SickleJr, k = 20)
}
\arguments{
\item{SickleJr}{An object of class SickleJr}

\item{k}{Number of KNN neighbors to calculate SNN graph; defaults to 20}
}
\value{
An object of class SickleJr with list of graph Laplacians in sparse
matrix format added to its \code{graph.laplacian.list} slot
}
\description{
Generate graph Laplacians for graph regularization of
jrSiCKLSNMF from the list of raw count matrices using an SNN graph. SNN is more robust to
situations where the number of cells outnumbers the number of features. Uses
the \code{scran} package's \code{BuildSNNGraph} function \insertCite{Lun2016}{jrSiCKLSNMF}
}
\examples{
SimSickleJrSmall<-BuildSNNGraphLaplacians(SimSickleJrSmall)
}
\references{
\insertRef{Lun2016}{jrSiCKLSNMF}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{SetWandHfromWHinitials}
\alias{SetWandHfromWHinitials}
\title{Set \eqn{\mathbf{W}} matrices and \eqn{\mathbf{H}} matrix from pre-calculated values}
\usage{
SetWandHfromWHinitials(SickleJr, d)
}
\arguments{
\item{SickleJr}{An object of class SickleJr}

\item{d}{The number of desired latent factors}
}
\value{
An object of class SickleJr with the \code{Wlist} slot and the \code{H} slot filled from pre-calculated values.
}
\description{
Use values calculated in the step to determine number of latent factors in the initial
steps for the jrSiCKLSNMF algorithm. If only a subset was calculated, this produces an error.
In this case, please use \code{\link{GenerateWmatricesandHmatrix}} to generate new
\eqn{\mathbf{W}^v} matrices and a new \eqn{\mathbf{H}} matrix.
}
\examples{
SimSickleJrSmall<-SetWandHfromWHinitials(SimSickleJrSmall,d=5)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\docType{class}
\name{SickleJr-class}
\alias{SickleJr-class}
\alias{SickleJr}
\title{The SickleJr class}
\value{
An object of class SickleJr
}
\description{
Defines the SickleJr class for use with jrSiCKLSNMF. This object
contains all of the information required for analysis using jrSiCKLSNMF. This includes
count matrices, normalized matrices, graph Laplacians, hyperparameters, diagnostic plots,
and plots of cell clusters.
}
\section{Slots}{

\describe{
\item{\code{count.matrices}}{A list containing all of the quality controlled count matrices.
Note that these count matrices should not use all features and should
only include features that appear in at a minimum 10 cells.}

\item{\code{normalized.count.matrices}}{A list that holds the normalized count matrices}

\item{\code{graph.laplacian.list}}{A list of the graph Laplacians to be used for graph regularization}

\item{\code{rowRegularization}}{A string that indicates the type of row regularization to
use. Types include "None" and "L2Norm"}

\item{\code{diffFunc}}{A string that holds the name of the function used to measure the discrepancy between
data matrix X and WH for each modality; can be \code{"klp"} for the Poisson Kullback-Leibler divergence
or \code{"fr"} for the Frobenius norm}

\item{\code{lambdaWlist}}{A list of lambda values to use as the hyperparameters for the
corresponding \eqn{\mathbf{W}^v} in the \eqn{v^{\text{th}}} modality}

\item{\code{lambdaH}}{A numeric value corresponding to the hyperparameter of the sparsity constraint on \eqn{\mathbf{H}}}

\item{\code{Wlist}}{A list of the generated \eqn{\mathbf{W}^v} matrices, one for each modality}

\item{\code{H}}{The shared \eqn{\mathbf{H}} matrix}

\item{\code{WHinitials}}{A list that if, when using \code{\link{PlotLossvsLatentFactors}}, all of the cells are used to calculate
the initial values, stores these initial generated matrices; can be used
as initializations when running \code{\link{RunjrSiCKLSNMF}} to save time}

\item{\code{lossCalcSubsample}}{A vector that holds the cell indices on which \code{\link{PlotLossvsLatentFactors}} was calculated}

\item{\code{latent.factor.elbow.values}}{A data frame that holds the relevant information to plot the latent factor elbow plot}

\item{\code{minibatch}}{Indicator variable that states whether the algorithm should use mini-batch updates.}

\item{\code{clusterdiagnostics}}{List of the cluster diagnostic results for the SickleJr object. Includes diagnostic plots from \code{\link[factoextra]{fviz_nbclust}} and
and diagnostics from \code{\link[clValid]{clValid}}}

\item{\code{clusters}}{List of results of different clustering methods performed on the SickleJr object}

\item{\code{metadata}}{List of metadata}

\item{\code{loss}}{Vector of the value for the loss function}

\item{\code{umap}}{List of different UMAP-based dimension reductions using \code{\link[umap]{umap}}}

\item{\code{plots}}{Holds various \code{\link[ggplot2]{ggplot}} results for easy access of diagnostics and cluster visualizations}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{PlotLossvsLatentFactors}
\alias{PlotLossvsLatentFactors}
\title{Create plots to help determine the number of latent factors}
\usage{
PlotLossvsLatentFactors(
  SickleJr,
  rounds = 100,
  differr = 1e-04,
  d_vector = c(2:20),
  parallel = FALSE,
  nCores = detectCores() - 1,
  subsampsize = NULL,
  minibatch = FALSE,
  random = FALSE,
  random_W_updates = FALSE,
  seed = NULL,
  batchsize = -1,
  lossonsubset = FALSE,
  losssubsetsize = dim(SickleJr@count.matrices[[1]])[2]
)
}
\arguments{
\item{SickleJr}{An object of class SickleJr}

\item{rounds}{Number of rounds to use: defaults to 100; this process is time consuming,
so a high number of rounds is not recommended}

\item{differr}{Tolerance for the percentage update in the likelihood: for these plots,
this defaults to \eqn{1e-4}}

\item{d_vector}{Vector of \eqn{d} values to test: default is 2 to 20}

\item{parallel}{Boolean indicating whether to use parallel computation}

\item{nCores}{Number of desired cores; defaults to the number of cores of the current machine minus 1 for convenience}

\item{subsampsize}{Size of the random subsample (defaults to \code{NULL}, which means all cells will be used); using a random subsample decreases computation time but sacrifices accuracy}

\item{minibatch}{Boolean indicating whether to use the mini-batch algorithm: default is \code{FALSE}}

\item{random}{Boolean indicating whether to use random initialization to generate the \eqn{\mathbf{W}^v} matrices and \eqn{\mathbf{H}} matrix:
defaults to \code{FALSE}}

\item{random_W_updates}{Boolean parameter for mini-batch algorithm; if \code{TRUE}, only updates \eqn{\mathbf{W}^v} once per epoch on the
penultimate subset of \eqn{\mathbf{H}}; otherwise updates \eqn{\mathbf{W}^v} after every update of the subset of \eqn{\mathbf{H}}}

\item{seed}{Number representing the random seed}

\item{batchsize}{Desired batch size; do not use if using a subsample}

\item{lossonsubset}{Boolean indicating whether to calculate the loss on a subset rather than the full dataset; speeds up computation for larger datasets}

\item{losssubsetsize}{Number of cells to use for the loss subset; default is total number of cells}
}
\value{
An object of class SickleJr with a list of initialized \eqn{\mathbf{W}^v} matrices and an \eqn{\mathbf{H}} matrix
for each latent factor \eqn{d\in\{1,...,D\}} added to the \code{WHinitials} slot, a data frame holding relevant
values for plotting the elbow plot added to the \code{latent.factor.elbow.values} slot, diagnostic plots of the loss vs. the number of latent factors added to the \code{plots}
slot, and the cell indices used to calculate the loss on the subsample added to the \code{lossCalcSubSample} slot
}
\description{
Generate plots of the lowest achieved loss after a
pre-specified number of iterations (default 100) for each latent factor
(defaults to 2:20). This operates similarly to a scree plot, so please select
a number of latent factors that corresponds to the elbow of the plot.
This method is not appropriate for larger sets of data (more than 1000 cells)
}
\examples{
SimSickleJrSmall@latent.factor.elbow.values<-data.frame(NULL,NULL)
SimSickleJrSmall<-PlotLossvsLatentFactors(SimSickleJrSmall,d_vector=c(2:5),
rounds=5,parallel=FALSE)
#Next, we commute 2 of these in parallel.
\dontrun{
SimSickleJrSmall<-PlotLossvsLatentFactors(SimSickleJrSmall,
d_vector=c(6:7),rounds=5,parallel=TRUE,nCores=2)}
}
\references{
\insertRef{ggplot2}{jrSiCKLSNMF}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{jrSiCKLSNMF}
\alias{jrSiCKLSNMF}
\title{Run jrSiCKLSNMF outside of a SickleJr object}
\usage{
jrSiCKLSNMF(
  datamatL,
  WL,
  H,
  AdjL,
  DL,
  lambdaWL,
  lambdaH,
  initsamp,
  suppress_warnings,
  diffFunc = "klp",
  Hconstraint = "None",
  differr = 1e-06,
  rounds = 1000L,
  display_progress = TRUE,
  minibatch = TRUE,
  batchsize = 100L,
  random_W_updates = TRUE,
  minrounds = 100L
)
}
\arguments{
\item{datamatL}{An R list where each entry contains a normalized, sparse \eqn{\mathbf{X}^v} matrix corresponding to single-cell modality \eqn{v}}

\item{WL}{An R list containing initialized values of the \eqn{\mathbf{W}^v} within each modality \eqn{v}}

\item{H}{A matrix containing initialized values for the shared \eqn{\mathbf{H}}}

\item{AdjL}{An R list containing all of the adjacency matrices for the
feature-feature similarity graphs in sparse format; note that \eqn{\mathtt{D-Adj}} is the
graph Laplacian}

\item{DL}{An R list containing all of the degree matrices of the
feature-feature similarity graphs; note that \eqn{\mathtt{D-Adj}} is the graph Laplacian}

\item{lambdaWL}{A list of the \eqn{\lambda_{\mathbf{W}^v}} corresponding to modality \eqn{v}}

\item{lambdaH}{A double containing the desired value for \eqn{\lambda_{\mathbf{H}}}}

\item{initsamp}{A vector of randomly selected rows of \eqn{\mathtt{H}} on which to run the objective function}

\item{suppress_warnings}{A Boolean that indicates whether warnings should be suppressed}

\item{diffFunc}{A string indicating what type of divergence to use; set to the Poisson Kullback-Leibler divergence
(\eqn{\mathtt{``klp"}}) by default, but the Frobenius norm (\eqn{\mathtt{``fr"}}) is also available}

\item{Hconstraint}{A string that indicates whether you want to set an L2 norm constraint on the rows of \eqn{\mathbf{H}}. Enter `None` for
no constraints or `L2Norm` to set the L2 norm of each row of \eqn{\mathbf{H}} to 1}

\item{differr}{A double containing the tolerance}

\item{rounds}{A double containing the number of rounds}

\item{display_progress}{A Boolean indicating whether to display the progress bar}

\item{minibatch}{A Boolean indicating whether to use the mini-batch version of the algorithm}

\item{batchsize}{Number of batches for mini-batch updates}

\item{random_W_updates}{A Boolean indicating whether to update \eqn{\mathbf{W}^v} once per epoch (TRUE) or after every update of
the subset of \eqn{\mathbf{H}} (FALSE) for the mini-batch algorithm.}

\item{minrounds}{A minimum number of rounds for the algorithm to run: most useful for the mini-batch algorithm}
}
\value{
An R list containing values for the objective function.
}
\description{
Perform joint non-negative matrix factorization (NMF) across multiple modalities of single-cell data.
To measure the discrepancy between two distributions, one can use the Poisson Kullback-Leibler divergence (\eqn{\mathtt{diffFunc}=}\eqn{\mathtt{"klp"}})  or the Frobenius norm (\eqn{\mathtt{diffFunc}=}\eqn{\mathtt{"fr"}}).
It is also possible to set graph regularization constraints on \eqn{\mathbf{W}^v} and either a sparsity constraint on \eqn{\mathbf{H}} or an
L2 norm constraint on the rows of \eqn{\mathbf{H}}.
This function passes by reference and updates the variables \eqn{\mathtt{WL}} and \eqn{\mathtt{H}} and does not require data to be in an
object of type SickleJr. \eqn{\mathtt{RunjrSiCKLSNMF}} calls this function. If your data are in an object of class SickleJr,
please use the \eqn{\mathtt{RunjrSiCKLSNMF}} function instead.
}
\references{
\insertRef{Cai2008}{jrSiCKLSNMF}

\insertRef{jnmf2009}{jrSiCKLSNMF}

\insertRef{Eddelbuettel2011}{jrSiCKLSNMF}

\insertRef{Eddelbuettel2014}{jrSiCKLSNMF}

\insertRef{Elyanow2020}{jrSiCKLSNMF}

\insertRef{halfbakednmf}{jrSiCKLSNMF}

\insertRef{Lee1999}{jrSiCKLSNMF}

\insertRef{Liu2013}{jrSiCKLSNMF}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{CreateSickleJr}
\alias{CreateSickleJr}
\title{Create an object of class SickleJr}
\usage{
CreateSickleJr(count.matrices, names = NULL)
}
\arguments{
\item{count.matrices}{A list of quality-controlled count matrices with pre-filtered features where each modality corresponds to each matrix in the
list}

\item{names}{Optional parameter with names for the count matrices in vector format}
}
\value{
An object of class SickleJr with sparse count matrices added to the \code{count.matrices} slot
}
\description{
Using a list of sparse count matrices, create an object of class SickleJr
and specify the names of these count matrices.
}
\examples{
ExampleSickleJr<-CreateSickleJr(SimData$Xmatrices)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{PlotSickleJrUMAP}
\alias{PlotSickleJrUMAP}
\title{Generate UMAP plots for an object of class SickleJr}
\usage{
PlotSickleJrUMAP(
  SickleJr,
  umap.modality = "H",
  cluster = "kmeans",
  title = "",
  colorbymetadata = NULL,
  legendname = NULL
)
}
\arguments{
\item{SickleJr}{An object of class SickleJr}

\item{umap.modality}{String corresponding to the name of the UMAP of interest: defaults to \code{"H"}}

\item{cluster}{String input that indicates which cluster to color by: defaults to \code{"kmeans"}}

\item{title}{String input for optional \code{\link[ggplot2:ggplot]{ggplot}} plot title}

\item{colorbymetadata}{Name of metadata column if coloring by metadata}

\item{legendname}{String input that to allow specification of a different legend name}
}
\value{
An object of class SickleJr with plots added to the \code{plots} slot
}
\description{
Plot the first and second dimensions of a UMAP dimension reduction
and color either by clustering results or metadata.
}
\examples{
SimSickleJrSmall<-PlotSickleJrUMAP(SimSickleJrSmall,
title="K-Means Example")
SimSickleJrSmall<-PlotSickleJrUMAP(SimSickleJrSmall,umap.modality=1)
}
\references{
\insertRef{ggplot2}{jrSiCKLSNMF}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{SetLambdasandRowReg}
\alias{SetLambdasandRowReg}
\title{Set lambda values and type of row regularization for an object of class SickleJr}
\usage{
SetLambdasandRowReg(
  SickleJr,
  lambdaWlist = list(10, 50),
  lambdaH = 500,
  rowReg = "None"
)
}
\arguments{
\item{SickleJr}{An object of class SickleJr}

\item{lambdaWlist}{A list of graph regularization constraints for the \eqn{\mathbf{W}^v} matrices:
defaults to 2 modalities with the RNA modality constraint equal to 10 and the ATAC modality constraint equal to 50}

\item{lambdaH}{A numeric holding the sparsity constraint on \eqn{\mathbf{H}}: defaults to 500.}

\item{rowReg}{A string that is equal to \code{"None"} for no constraints on the rows of \eqn{\mathbf{H}} and \code{"L2Norm"}
to set the L2 norms of the rows of \eqn{\mathbf{H}} to be equal to 1: defaults to "None"}
}
\value{
An object of class SickleJr with the lambda hyperparameter values added to its \code{lambdaWlist} and \code{lambdaH} slots and with the
row regularization value added to its \code{rowRegularization} slot
}
\description{
Provide the values for the graph regularization \eqn{\lambda_{\textbf{W}^v}}
for each modality as a list, provide the value for the sparsity constraint \eqn{\lambda_{\mathbf{H}}},
and select whether to use L2 norm regularization.
}
\examples{
SimSickleJrSmall<-SetLambdasandRowReg(SimSickleJrSmall,
lambdaWlist=list(10,50),lambdaH=500,rowReg="None")
SimSickleJrSmall<-SetLambdasandRowReg(SimSickleJrSmall,
lambdaWlist=list(3,15),lambdaH=0,rowReg="L2Norm")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{BuildKNNGraphLaplacians}
\alias{BuildKNNGraphLaplacians}
\title{Build KNN graphs and generate their graph Laplacians}
\usage{
BuildKNNGraphLaplacians(SickleJr, k = 20)
}
\arguments{
\item{SickleJr}{An object of class SickleJr}

\item{k}{Number of KNN neighbors to calculate; by default, is set to 20}
}
\value{
An object of class SickleJr with a list of graph Laplacians in sparse matrix format
added to the \code{graph.laplacian.list} slot
}
\description{
Generate graph Laplacians for graph regularization of
jrSiCKLSNMF from the list of raw count matrices using a KNN graph. Note that this
is only appropriate when the number of features is considerably greater
than the number of cells in all modalities. If this is not the case, please use
\code{\link{BuildSNNGraphLaplacians}} or any other method of graph
construction that does not rely on the Euclidean distance and store the graph Laplacians for
each modality as a list in the \code{graph.laplacian.list} slot.
}
\examples{
SimSickleJrSmall<-BuildKNNGraphLaplacians(SimSickleJrSmall)
}
\references{
\insertRef{Lun2016}{jrSiCKLSNMF}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jrSiCKLSNMF.R
\name{AddSickleJrMetadata}
\alias{AddSickleJrMetadata}
\title{Add metadata to an object of class SickleJr}
\usage{
AddSickleJrMetadata(SickleJr, metadata, metadataname)
}
\arguments{
\item{SickleJr}{An object of class SickleJr holding at least one count matrix of omics data}

\item{metadata}{Metadata to add to the SickleJr object; there are no restrictions on type}

\item{metadataname}{A string input that indicates the desired name for the added
metadata.}
}
\value{
An object of class SickleJr with added metadata
}
\description{
Add any type of metadata to an object of class SickleJr. Metadata
are stored in list format under the name specified in \code{metadataname} of each node in slot \code{metadata}.
}
\examples{
SimSickleJrSmall<-AddSickleJrMetadata(SimSickleJrSmall,
SimData$cell_type,"cell_types_full_data")
}
